regina::NTriangulation Class Referenceabstract
Triangulations

Stores the triangulation of a 3-manifold along with its various cellular structures and other information. More...

`#include <triangulation/ntriangulation.h>`

Inheritance diagram for regina::NTriangulation:

## Public Types

typedef std::vector< NTetrahedron * >::const_iterator | TetrahedronIterator
| Used to iterate through tetrahedra. More...
typedef std::vector< NTriangle * >::const_iterator | TriangleIterator
| Used to iterate through triangles. More...
typedef std::vector< NTriangle * >::const_iterator | FaceIterator
| A deprecated alias for TriangleIterator. More...
typedef std::vector< NEdge * >::const_iterator | EdgeIterator
| Used to iterate through edges. More...
typedef std::vector< NVertex * >::const_iterator | VertexIterator
| Used to iterate through vertices. More...
typedef std::vector< NComponent * >::const_iterator | ComponentIterator
| Used to iterate through components. More...
typedef std::vector< NBoundaryComponent * >::const_iterator | BoundaryComponentIterator
| Used to iterate through boundary components. More...
typedef std::map< std::pair< unsigned long, unsigned long >, double > | TuraevViroSet
| A map from (r, whichRoot) pairs to Turaev-Viro invariants. More...
typedef ChangeEventSpan | ChangeEventBlock
| A deprecated typedef for ChangeEventSpan. More...
typedef void | Triangulation
| The main data type for a dim-manifold triangulation. More...
typedef void | Simplex
| The data type for a top-dimensional simplex in a dim-manifold triangulation. More...
typedef void | Isomorphism
| The data type for an isomorphism between two dim-manifold triangulations. More...
typedef void | FacetPairing
| The data type that represents a pairing of facets of top-dimensional simplices in a dim-manifold triangulation. More...
typedef void | Perm
| The permutation type used to describe gluings between top-dimensional simplices in a dim-manifold triangulation. More...

## Public Member Functions

template<>
unsigned long | getNumberOfFaces () const
template<>
unsigned long | getNumberOfFaces () const
template<>
unsigned long | getNumberOfFaces () const
template<>
unsigned long | getNumberOfFaces () const
Constructors and Destructors
| NTriangulation ()
| Default constructor. More...
| NTriangulation (const NTriangulation &cloneMe)
| Copy constructor. More...
| NTriangulation (const std::string &description)
| "Magic" constructor that tries to find some way to interpret the given string as a triangulation. More...
virtual | ~NTriangulation ()
| Destroys this triangulation. More...
Packet Administration
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
Tetrahedra
unsigned long | getNumberOfTetrahedra () const
| Returns the number of tetrahedra in the triangulation. More...
unsigned long | getNumberOfSimplices () const
| A dimension-agnostic alias for getNumberOfTetrahedra(). More...
const std::vector< NTetrahedron * > & | getTetrahedra () const
| Returns all tetrahedra in the triangulation. More...
const std::vector< NTetrahedron * > & | getSimplices () const
| A dimension-agnostic alias for getTetrahedra(). More...
NTetrahedron * | getTetrahedron (unsigned long index)
| Returns the tetrahedron with the given index number in the triangulation. More...
NTetrahedron * | getSimplex (unsigned long index)
| A dimension-agnostic alias for getTetrahedron(). More...
const NTetrahedron * | getTetrahedron (unsigned long index) const
| Returns the tetrahedron with the given index number in the triangulation. More...
const NTetrahedron * | getSimplex (unsigned long index) const
| A dimension-agnostic alias for getTetrahedron(). More...
long | tetrahedronIndex (const NTetrahedron *tet) const
| Returns the index of the given tetrahedron in the triangulation. More...
long | simplexIndex (const NTetrahedron *tet) const
| A dimension-agnostic alias for tetrahedronIndex(). More...
NTetrahedron * | newTetrahedron ()
| Creates a new tetrahedron and adds it to this triangulation. More...
NTetrahedron * | newSimplex ()
| A dimension-agnostic alias for newTetrahedron(). More...
NTetrahedron * | newTetrahedron (const std::string &desc)
| Creates a new tetrahedron with the given description and adds it to this triangulation. More...
NTetrahedron * | newSimplex (const std::string &desc)
| A dimension-agnostic alias for newTetrahedron(). More...
void | addTetrahedron (NTetrahedron *tet)
| Inserts the given tetrahedron into the triangulation. More...
void | removeTetrahedron (NTetrahedron *tet)
| Removes the given tetrahedron from the triangulation. More...
void | removeSimplex (NTetrahedron *tet)
| A dimension-agnostic alias for removeTetrahedron(). More...
void | removeTetrahedronAt (unsigned long index)
| Removes the tetrahedron with the given index number from the triangulation. More...
void | removeSimplexAt (unsigned long index)
| A dimension-agnostic alias for removeTetrahedronAt(). More...
void | removeAllTetrahedra ()
| Removes all tetrahedra from the triangulation. More...
void | removeAllSimplices ()
| A dimension-agnostic alias for removeAllTetrahedra(). More...
void | swapContents (NTriangulation &other)
| Swaps the contents of this and the given triangulation. More...
void | moveContentsTo (NTriangulation &dest)
| Moves the contents of this triangulation into the given destination triangulation, without destroying any pre-existing contents. More...
void | gluingsHaveChanged ()
| This routine now does nothing, and should not be used. More...
Skeletal Queries
unsigned long | getNumberOfBoundaryComponents () const
| Returns the number of boundary components in this triangulation. More...
unsigned long | getNumberOfComponents () const
| Returns the number of components in this triangulation. More...
unsigned long | getNumberOfVertices () const
| Returns the number of vertices in this triangulation. More...
unsigned long | getNumberOfEdges () const
| Returns the number of edges in this triangulation. More...
unsigned long | getNumberOfTriangles () const
| Returns the number of triangular faces in this triangulation. More...
unsigned long | getNumberOfFaces () const
| A deprecated alias for getNumberOfTriangles(). More...
template<int dim>
unsigned long | getNumberOfFaces () const
| Returns the number of faces of the given dimension in this triangulation. More...
const std::vector< NComponent * > & | getComponents () const
| Returns all components of this triangulation. More...
const std::vector< NBoundaryComponent * > & | getBoundaryComponents () const
| Returns all boundary components of this triangulation. More...
const std::vector< NVertex * > & | getVertices () const
| Returns all vertices of this triangulation. More...
const std::vector< NEdge * > & | getEdges () const
| Returns all edges of this triangulation. More...
const std::vector< NTriangle * > & | getTriangles () const
| Returns all triangular faces of this triangulation. More...
const std::vector< NTriangle * > & | getFaces () const
| A deprecated alias for getTriangles(). More...
NComponent * | getComponent (unsigned long index) const
| Returns the requested triangulation component. More...
NBoundaryComponent * | getBoundaryComponent (unsigned long index) const
| Returns the requested triangulation boundary component. More...
NVertex * | getVertex (unsigned long index) const
| Returns the requested vertex in this triangulation. More...
NEdge * | getEdge (unsigned long index) const
| Returns the requested edge in this triangulation. More...
NTriangle * | getTriangle (unsigned long index) const
| Returns the requested triangular face in this triangulation. More...
NTriangle * | getFace (unsigned long index) const
| A deprecated alias for getTriangle(). More...
long | componentIndex (const NComponent *component) const
| Returns the index of the given component in the triangulation. More...
long | boundaryComponentIndex (const NBoundaryComponent *bc) const
| Returns the index of the given boundary component in the triangulation. More...
long | vertexIndex (const NVertex *vertex) const
| Returns the index of the given vertex in the triangulation. More...
long | edgeIndex (const NEdge *edge) const
| Returns the index of the given edge in the triangulation. More...
long | triangleIndex (const NTriangle *triangle) const
| Returns the index of the given triangle in the triangulation. More...
long | faceIndex (const NTriangle *triangle) const
| A deprecated alias for triangleIndex(). More...
bool | hasTwoSphereBoundaryComponents () const
| Determines if this triangulation contains any two-sphere boundary components. More...
bool | hasNegativeIdealBoundaryComponents () const
| Determines if this triangulation contains any ideal boundary components with negative Euler characteristic. More...
Basic Properties
long | getEulerCharTri () const
| Returns the Euler characteristic of this triangulation. More...
long | getEulerCharManifold () const
| Returns the Euler characteristic of the corresponding compact 3-manifold. More...
long | getEulerCharacteristic () const
| A deprecated alias for getEulerCharTri(). More...
bool | isValid () const
| Determines if this triangulation is valid. More...
bool | isIdeal () const
| Determines if this triangulation is ideal. More...
bool | isStandard () const
| Determines if this triangulation is standard. More...
bool | hasBoundaryTriangles () const
| Determines if this triangulation has any boundary triangles. More...
bool | hasBoundaryFaces () const
| A deprecated alias for hasBoundaryTriangles(). More...
unsigned long | getNumberOfBoundaryTriangles () const
| Returns the number of boundary triangles in this triangulation. More...
bool | isClosed () const
| Determines if this triangulation is closed. More...
bool | isOrientable () const
| Determines if this triangulation is orientable. More...
bool | isOriented () const
| Determines if this triangulation is oriented; that is, if tetrahedron vertices are labelled in a way that preserves orientation across adjacent tetrahedron faces. More...
bool | isOrdered () const
| Determines if this triangulation is ordered; that is, if tetrahedron vertices are labelled so that all gluing permutations are order-preserving on the tetrahedron faces. More...
bool | isConnected () const
| Determines if this triangulation is connected. More...
Algebraic Properties
const NGroupPresentation & | getFundamentalGroup () const
| Returns the fundamental group of this triangulation. More...
void | simplifiedFundamentalGroup (NGroupPresentation *newGroup)
| Notifies the triangulation that you have simplified the presentation of its fundamental group. More...
const NAbelianGroup & | getHomologyH1 () const
| Returns the first homology group for this triangulation. More...
const NAbelianGroup & | getHomologyH1Rel () const
| Returns the relative first homology group with respect to the boundary for this triangulation. More...
const NAbelianGroup & | getHomologyH1Bdry () const
| Returns the first homology group of the boundary for this triangulation. More...
const NAbelianGroup & | getHomologyH2 () const
| Returns the second homology group for this triangulation. More...
unsigned long | getHomologyH2Z2 () const
| Returns the second homology group with coefficients in Z_2 for this triangulation. More...
double | turaevViro (unsigned long r, unsigned long whichRoot) const
| Computes the Turaev-Viro state sum invariant of this 3-manifold based upon the given initial data. More...
const TuraevViroSet & | allCalculatedTuraevViro () const
| Returns the set of all Turaev-Viro state sum invariants that have already been calculated for this 3-manifold. More...
Normal Surfaces and Angle Structures
bool | isZeroEfficient ()
| Determines if this triangulation is 0-efficient. More...
bool | knowsZeroEfficient () const
| Is it already known whether or not this triangulation is 0-efficient? See isZeroEfficient() for further details. More...
bool | hasSplittingSurface ()
| Determines whether this triangulation has a normal splitting surface. More...
bool | knowsSplittingSurface () const
| Is it already known whether or not this triangulation has a splitting surface? See hasSplittingSurface() for further details. More...
NNormalSurface * | hasNonTrivialSphereOrDisc ()
| Searches for a non-vertex-linking normal sphere or disc within this triangulation. More...
NNormalSurface * | hasOctagonalAlmostNormalSphere ()
| Searches for an octagonal almost normal 2-sphere within this triangulation. More...
const NAngleStructure * | findStrictAngleStructure () const
| Searches for a strict angle structure on this triangulation. More...
bool | hasStrictAngleStructure () const
| Determines whether this triangulation supports a strict angle structure. More...
bool | knowsStrictAngleStructure () const
| Is it already known (or trivial to determine) whether or not this triangulation supports a strict angle structure? See hasStrictAngleStructure() for further details. More...
Skeletal Transformations
void | maximalForestInBoundary (std::set< NEdge * > &edgeSet, std::set< NVertex * > &vertexSet) const
| Produces a maximal forest in the 1-skeleton of the triangulation boundary. More...
void | maximalForestInSkeleton (std::set< NEdge * > &edgeSet, bool canJoinBoundaries=true) const
| Produces a maximal forest in the triangulation's 1-skeleton. More...
void | maximalForestInDualSkeleton (std::set< NTriangle * > &triangleSet) const
| Produces a maximal forest in the triangulation's dual 1-skeleton. More...
bool | intelligentSimplify ()
| Attempts to simplify the triangulation as intelligently as possible without further input. More...
bool | simplifyToLocalMinimum (bool perform=true)
| Uses all known simplification moves to reduce the triangulation monotonically to some local minimum number of tetrahedra. More...
bool | threeTwoMove (NEdge *e, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 3-2 move about the given edge. More...
bool | twoThreeMove (NTriangle *t, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 2-3 move about the given triangle. More...
bool | oneFourMove (NTetrahedron *t, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 1-4 move upon the given tetrahedron. More...
bool | fourFourMove (NEdge *e, int newAxis, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 4-4 move about the given edge. More...
bool | twoZeroMove (NEdge *e, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 2-0 move about the given edge of degree 2. More...
bool | twoZeroMove (NVertex *v, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 2-0 move about the given vertex of degree 2. More...
bool | twoOneMove (NEdge *e, int edgeEnd, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a 2-1 move about the given edge. More...
bool | openBook (NTriangle *t, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a book opening move about the given triangle. More...
bool | closeBook (NEdge *e, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a book closing move about the given boundary edge. More...
bool | shellBoundary (NTetrahedron *t, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a boundary shelling move on the given tetrahedron. More...
bool | collapseEdge (NEdge *e, bool check=true, bool perform=true)
| Checks the eligibility of and/or performs a collapse of an edge in such a way that the topology of the manifold does not change and the number of vertices of the triangulation decreases by one. More...
void | reorderTetrahedraBFS (bool reverse=false)
| Reorders the tetrahedra of this triangulation using a breadth-first search, so that small-numbered tetrahedra are adjacent to other small-numbered tetrahedra. More...
void | orient ()
| Relabels tetrahedron vertices in this triangulation so that all tetrahedra are oriented consistently, if possible. More...
bool | order (bool forceOriented=false)
| Relabels tetrahedron vertices in this triangulation to give an ordered triangulation, if possible. More...
Decompositions
unsigned long | splitIntoComponents (NPacket *componentParent=0, bool setLabels=true)
| Splits a disconnected triangulation into many smaller triangulations, one for each component. More...
long | connectedSumDecomposition (NPacket *primeParent=0, bool setLabels=true)
| Splits this triangulation into its connected sum decomposition. More...
bool | isThreeSphere () const
| Determines whether this is a triangulation of a 3-sphere. More...
bool | knowsThreeSphere () const
| Is it already known (or trivial to determine) whether or not this is a triangulation of a 3-sphere? See isThreeSphere() for further details. More...
bool | isBall () const
| Determines whether this is a triangulation of a 3-dimensional ball. More...
bool | knowsBall () const
| Is it already known (or trivial to determine) whether or not this is a triangulation of a 3-dimensional ball? See isBall() for further details. More...
NPacket * | makeZeroEfficient ()
| Converts this into a 0-efficient triangulation of the same underlying 3-manifold. More...
bool | isSolidTorus () const
| Determines whether this is a triangulation of the solid torus; that is, the unknot complement. More...
bool | knowsSolidTorus () const
| Is it already known (or trivial to determine) whether or not this is a triangulation of a solid torus (that is, the unknot complement)? See isSolidTorus() for further details. More...
bool | isIrreducible () const
| Determines whether the underlying 3-manifold (which must be closed) is irreducible. More...
bool | knowsIrreducible () const
| Is it already known (or trivial to determine) whether or not the underlying 3-manifold is irreducible? See isIrreducible() for further details. More...
bool | hasCompressingDisc () const
| Searches for a compressing disc within the underlying 3-manifold. More...
bool | knowsCompressingDisc () const
| Is it already known (or trivial to determine) whether or not the underlying 3-manifold contains a compressing disc? See hasCompressingDisc() for further details. More...
bool | isHaken () const
| Determines whether the underlying 3-manifold (which must be closed and orientable) is Haken. More...
bool | knowsHaken () const
| Is it already known (or trivial to determine) whether or not the underlying 3-manifold is Haken? See isHaken() for further details. More...
bool | hasSimpleCompressingDisc () const
| Searches for a "simple" compressing disc inside this triangulation. More...
Subdivisions, Extensions and Covers
void | makeDoubleCover ()
| Converts this triangulation into its double cover. More...
bool | idealToFinite (bool forceDivision=false)
| Converts an ideal triangulation into a finite triangulation. More...
bool | finiteToIdeal ()
| Converts each real boundary component into a cusp (i.e., an ideal vertex). More...
void | barycentricSubdivision ()
| Does a barycentric subdivision of the triangulation. More...
void | drillEdge (NEdge *e)
| Drills out a regular neighbourhood of the given edge of the triangulation. More...
void | puncture (NTetrahedron *tet=0)
| Punctures this manifold by removing a 3-ball from the interior of the given tetrahedron. More...
Building Triangulations
NTetrahedron * | layerOn (NEdge *edge)
| Performs a layering upon the given boundary edge of the triangulation. More...
NTetrahedron * | insertLayeredSolidTorus (unsigned long cuts0, unsigned long cuts1)
| Inserts a new layered solid torus into the triangulation. More...
void | insertLayeredLensSpace (unsigned long p, unsigned long q)
| Inserts a new layered lens space L(p,q) into the triangulation. More...
void | insertLayeredLoop (unsigned long length, bool twisted)
| Inserts a layered loop of the given length into this triangulation. More...
void | insertAugTriSolidTorus (long a1, long b1, long a2, long b2, long a3, long b3)
| Inserts an augmented triangular solid torus with the given parameters into this triangulation. More...
void | insertSFSOverSphere (long a1=1, long b1=0, long a2=1, long b2=0, long a3=1, long b3=0)
| Inserts an orientable Seifert fibred space with at most three exceptional fibres over the 2-sphere into this triangulation. More...
void | connectedSumWith (const NTriangulation &other)
| Forms the connected sum of this triangulation with the given triangulation. More...
void | insertTriangulation (const NTriangulation &source)
| Inserts a copy of the given triangulation into this triangulation. More...
bool | insertRehydration (const std::string &dehydration)
| Inserts the rehydration of the given string into this triangulation. More...
void | insertConstruction (unsigned long nTetrahedra, const int adjacencies[][4], const int gluings[][4][4])
| Inserts into this triangulation a set of tetrahedra and their gluings as described by the given integer arrays. More...
Exporting Triangulations
std::string | dehydrate () const
| Dehydrates this triangulation into an alphabetical string. More...
std::string | dumpConstruction () const
| Returns C++ code that can be used with insertConstruction() to reconstruct this triangulation. More...
virtual std::string | snapPea () const
| Returns a string containing the full contents of a SnapPea data file that describes this triangulation. More...
virtual void | snapPea (std::ostream &out) const
| Writes the full contents of a SnapPea data file describing this triangulation to the given output stream. More...
virtual bool | saveSnapPea (const char *filename) const
| Writes this triangulation to the given file using SnapPea's native file format. More...
std::string | recogniser () const
| Returns a string that expresses this triangulation in Matveev's 3-manifold recogniser format. More...
std::string | recognizer () const
| A synonym for recogniser(). More...
void | recogniser (std::ostream &out) const
| Writes a string expressing this triangulation in Matveev's 3-manifold recogniser format to the given output stream. More...
void | recognizer (std::ostream &out) const
| A synonym for recognizer(std::ostream&). More...
bool | saveRecogniser (const char *filename) const
| Writes this triangulation to the given file in Matveev's 3-manifold recogniser format. More...
bool | saveRecognizer (const char *filename) const
| A synonym for saveRecogniser(). More...
Packet Identification
virtual PacketType | getPacketType () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | getPacketTypeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | getPacketLabel () const
| Returns the label associated with this individual packet. More...
std::string | getHumanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
void | setPacketLabel (const std::string &newLabel)
| Sets the label associated with this individual packet. More...
std::string | getFullName () const
| Returns a descriptive text string for the packet. More...
std::string | makeUniqueLabel (const std::string &base) const
| Returns a new label that cannot be found anywhere in the entire tree structure. More...
bool | makeUniqueLabels (NPacket *reference)
| Ensures that all packet labels in both this and the given packet tree combined are distinct. More...
Tags
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | getTags () const
| Returns the set of all tags associated with this packet. More...
Event Handling
bool | listen (NPacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (NPacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (NPacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
Tree Queries
NPacket * | getTreeParent () const
| Determines the parent packet in the tree structure. More...
NPacket * | getFirstTreeChild () const
| Determines the first child of this packet in the tree structure. More...
NPacket * | getLastTreeChild () const
| Determines the last child of this packet in the tree structure. More...
NPacket * | getNextTreeSibling () const
| Determines the next sibling of this packet in the tree structure. More...
NPacket * | getPrevTreeSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
NPacket * | getTreeMatriarch () const
| Determines the matriarch (the root) of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const NPacket *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const NPacket *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const NPacket *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
unsigned long | getNumberOfChildren () const
| Returns the number of immediate children of this packet. More...
unsigned long | getNumberOfDescendants () const
| Returns the total number of descendants of this packet. More...
unsigned long | getTotalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
Tree Manipulation
void | insertChildFirst (NPacket *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (NPacket *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (NPacket *newChild, NPacket *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (NPacket *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
Searching and Iterating
NPacket * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const NPacket * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
NPacket * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const NPacket * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
NPacket * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const NPacket * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
NPacket * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const NPacket * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
Packet Dependencies
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
Cloning
NPacket * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
File I/O
bool | save (const char *filename, bool compressed=true) const
| Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format. More...
void | writeXMLFile (std::ostream &out) const
| Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
Input and Output
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...
Basic Properties
bool | isEmpty () const
| Determines whether this triangulation is empty. More...
Isomorphism Testing
bool | isIdenticalTo (const typename DimTraits< dim >::Triangulation &other) const
| Determines if this triangulation is combinatorially identical to the given triangulation. More...
std::auto_ptr< typename DimTraits< dim >::Isomorphism > | isIsomorphicTo (const typename DimTraits< dim >::Triangulation &other) const
| Determines if this triangulation is combinatorially isomorphic to the given triangulation. More...
std::auto_ptr< typename DimTraits< dim >::Isomorphism > | isContainedIn (const typename DimTraits< dim >::Triangulation &other) const
| Determines if an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components). More...
unsigned long | findAllIsomorphisms (const typename DimTraits< dim >::Triangulation &other, std::list< typename DimTraits< dim >::Isomorphism * > &results) const
| Finds all ways in which this triangulation is combinatorially isomorphic to the given triangulation. More...
unsigned long | findAllSubcomplexesIn (const typename DimTraits< dim >::Triangulation &other, std::list< typename DimTraits< dim >::Isomorphism * > &results) const
| Finds all ways in which an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components). More...
bool | makeCanonical ()
| Relabel the top-dimensional simplices and their vertices so that this triangulation is in canonical form. More...
Exporting Triangulations
std::string | isoSig (typename DimTraits< dim >::Isomorphism **relabelling=0) const
| Constructs the isomorphism signature for this triangulation. More...

## Static Public Member Functions

static NXMLPacketReader * | getXMLReader (NPacket *parent, NXMLTreeResolver &resolver)
Importing Triangulations
static NTriangulation * | enterTextTriangulation (std::istream &in, std::ostream &out)
| Allows the user to interactively enter a triangulation in plain text. More...
static NTriangulation * | rehydrate (const std::string &dehydration)
| Rehydrates the given alphabetical string into a new triangulation. More...
static NTriangulation * | fromSnapPea (const std::string &snapPeaData)
| Extracts the tetrahedron gluings from a string that contains the full contents of a SnapPea data file. More...
Importing Triangulations
static DimTraits< dim >::Triangulation * | fromIsoSig (const std::string &sig)
| Recovers a full triangulation from an isomorphism signature. More...
static size_t | isoSigComponentSize (const std::string &sig)
| Deduces the number of top-dimensional simplices in a connected triangulation from its isomorphism signature. More...

## Protected Member Functions

virtual NPacket * | internalClonePacket (NPacket *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...
void | cloneFrom (const NTriangulation &from)
| Turns this triangulation into a clone of the given triangulation. More...
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...

## Friends

class | regina::NGenericTriangulation< 3 >
class | regina::NTetrahedron
class | regina::NXMLTriangulationReader

## Detailed Description

Stores the triangulation of a 3-manifold along with its various cellular structures and other information.

When the triangulation is deleted, the corresponding tetrahedra, the cellular structure and all other properties will be deallocated.

Triangles, edges, vertices and components are always temporary; whenever a change occurs with the triangulation, these will be deleted and a new skeletal structure will be calculated. The same is true of various other triangulation properties.

The management of tetrahedra within a triangulation has become simpler and safer as of Regina 4.90. In older versions (Regina 4.6 and earlier), users were required to create tetrahedra, individually add them to triangulations, and manually notify a triangulation whenever its tetrahedron gluings changed. As of Regina 4.90, new tetrahedra are created using NTriangulation::newTetrahedron() which automatically places them within a triangulation, and all gluing changes are likewise communicated to the triangulation automatically. These are part of a larger suite of changes (all designed to help the user avoid inconsistent states and accidental crashes); see the NTetrahedron class notes for further details.

Todo:

  Feature: Is the boundary incompressible?

  Feature (long-term): Am I obviously a handlebody? (Simplify and see if there is nothing left). Am I obviously not a handlebody? (Compare homology with boundary homology).

  Feature (long-term): Is the triangulation Haken?

  Feature (long-term): What is the Heegaard genus?

  Feature (long-term): Have a subcomplex as a child packet of a triangulation. Include routines to crush a subcomplex or to expand a subcomplex to a normal surface.

  Feature (long-term): Implement writeTextLong() for skeletal objects.

## Member Typedef Documentation

typedef std::vector<NBoundaryComponent*>::const_iterator regina::NTriangulation::BoundaryComponentIterator

Used to iterate through boundary components.

typedef ChangeEventSpan regina::NPacket::ChangeEventBlock

inherited

A deprecated typedef for ChangeEventSpan.

Deprecated:
  ChangeEventSpan is now the correct way to fire a "packet changed" event. The class ChangeEventSpan is similar to the old ChangeEventBlock except that it fires both NPacketListener::packetToBeChanged() and NPacketListener::packetWasChanged() (on construction and destruction respectively), and the old boolean argument fireOnDestruction is gone (events are now fired always).

typedef std::vector<NComponent*>::const_iterator regina::NTriangulation::ComponentIterator

Used to iterate through components.

typedef std::vector<NEdge*>::const_iterator regina::NTriangulation::EdgeIterator

Used to iterate through edges.

typedef std::vector<NTriangle*>::const_iterator regina::NTriangulation::FaceIterator

A deprecated alias for TriangleIterator.

typedef std::vector<NTetrahedron*>::const_iterator regina::NTriangulation::TetrahedronIterator

Used to iterate through tetrahedra.

typedef std::vector<NTriangle*>::const_iterator regina::NTriangulation::TriangleIterator

Used to iterate through triangles.

typedef std::map<std::pair<unsigned long, unsigned long>, double> regina::NTriangulation::TuraevViroSet

A map from (r, whichRoot) pairs to Turaev-Viro invariants.

typedef std::vector<NVertex*>::const_iterator regina::NTriangulation::VertexIterator

Used to iterate through vertices.

## Constructor & Destructor Documentation

regina::NTriangulation::NTriangulation | ( |  | ) |

inline

Default constructor.

Creates an empty triangulation.

regina::NTriangulation::NTriangulation | ( | const NTriangulation & | cloneMe | ) |

inline

Copy constructor.

Creates a new triangulation identical to the given triangulation. The packet tree structure and packet label are not copied.

Parameters

  cloneMe | the triangulation to clone.

regina::NTriangulation::NTriangulation | ( | const std::string & | description | ) |

"Magic" constructor that tries to find some way to interpret the given string as a triangulation.

At present, Regina understands the following types of strings (and attempts to parse them in the following order):

- isomorphism signatures (see fromIsoSig());
- dehydration strings (see rehydrate());
- the contents of a SnapPea data file (see fromSnapPea()).

This list may grow in future versions of Regina.

Regina will also set the packet label accordingly.

If Regina cannot interpret the given string, this will be left as the empty triangulation.

Warning
  If you pass the contents of a SnapPea data file, then only the tetrahedron gluings will be read; all other SnapPea-specific information (such as peripheral curves) will be lost. See fromSnapPea() for details, and for other alternatives that preserve SnapPea-specific data.

Parameters

  description | a string that describes a 3-manifold triangulation.

regina::NTriangulation::~NTriangulation | ( |  | ) |

inline virtual

Destroys this triangulation.

The constituent tetrahedra, the cellular structure and all other properties will also be deallocated.

## Member Function Documentation

bool regina::NPacket::addTag | ( | const std::string & | tag | ) |

inherited

Associates the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Precondition
  The given tag is not the empty string.

Parameters

  tag | the tag to add.

Returns
  `true` if the given tag was successfully added, or `false` if the given tag was already present beforehand.

void regina::NTriangulation::addTetrahedron | ( | NTetrahedron * | tet | ) |

Inserts the given tetrahedron into the triangulation.

No face gluings anywhere will be examined or altered.

The new tetrahedron will be assigned a higher index in the triangulation than all tetrahedra already present.

Precondition
  The given tetrahedron does not already belong to a different triangulation (though already belonging to this triangulation is perfectly fine).

Deprecated:
  Users should create tetrahedra by calling newTetrahedron() or newTetrahedron(const std::string&), which will add the tetrahedron to the triangulation automatically.

Warning
  As of Regina 4.90, this routine will also add any neighbouring tetrahedra that do not yet belong to a triangulation; moreover, this addition is recursive. This is done to ensure that, whenever one tetrahedron belongs to a triangulation, everything that it is joined to (directly or indirectly) also belongs to that same triangulation. See the NTetrahedron class notes for further details on how tetrahedron management has changed in Regina 4.90 and above.

Python:
  Since this triangulation takes ownership of the given tetrahedron, the python object containing the given tetrahedron becomes a null object and should no longer be used.

Parameters

  tet | the tetrahedron to insert.

const NTriangulation::TuraevViroSet & regina::NTriangulation::allCalculatedTuraevViro | ( |  | ) | const

inline

Returns the set of all Turaev-Viro state sum invariants that have already been calculated for this 3-manifold.

Turaev-Viro invariants are described by an (r, whichRoot) pair as described in the turaevViro() notes. The set returned by this routine maps (r, whichRoot) pairs to the corresponding invariant values.

Each time turaevViro() is called, the result will be stored in this set (as well as being returned to the user). This set will be emptied whenever the triangulation is modified.

Python:
  Not present.

Returns
  the set of all Turaev-Viro invariants that have already been calculated.

See also
  turaevViro

void regina::NTriangulation::barycentricSubdivision | ( |  | ) |

Does a barycentric subdivision of the triangulation.

Each tetrahedron is divided into 24 tetrahedra by placing an extra vertex at the centroid of each tetrahedron, the centroid of each triangle and the midpoint of each edge.

Author
  David Letscher

long regina::NTriangulation::boundaryComponentIndex | ( | const NBoundaryComponent * | bc | ) | const

inline

Returns the index of the given boundary component in the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getBoundaryComponentIndex(). The name has been changed because, unlike the old routine, it requires that the given boundary component belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given boundary component belongs to this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program.

Parameters

  bc | specifies which boundary component to find in the triangulation.

Returns
  the index of the specified boundary component, where 0 is the first boundary component, 1 is the second and so on.

NPacket* regina::NPacket::clone | ( | bool | cloneDescendants = `false`,
|  | bool | end = `true`
| ) |  | const

inherited

Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet.

Note that any string tags associated with this packet will not be cloned.

If this packet has no parent in the tree structure, no clone will be created and 0 will be returned.

Parameters

  cloneDescendants | `true` if the descendants of this packet should also be cloned and inserted as descendants of the new packet. If this is passed as `false` (the default), only this packet will be cloned.
  end | `true` if the new packet should be inserted at the end of the parent's list of children (the default), or `false` if the new packet should be inserted as the sibling immediately after this packet.

Returns
  the newly inserted packet, or 0 if this packet has no parent.

void regina::NTriangulation::cloneFrom | ( | const NTriangulation & | from | ) |

protected

Turns this triangulation into a clone of the given triangulation.

The tree structure and label of this triangulation are not touched.

Parameters

  from | the triangulation from which this triangulation will be cloned.

bool regina::NTriangulation::closeBook | ( | NEdge * | e,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a book closing move about the given boundary edge.

This involves taking a boundary edge of the triangulation and folding together the two boundary triangles on either side. This move is the inverse of the openBook() move, and is used to simplify the boundary of the triangulation. This move can be done if:

- the edge e is a boundary edge;
- the two boundary triangles that it joins are distinct;
- the two vertices opposite e in each of these boundary triangles are valid and distinct;
- if edges e1 and e2 of one boundary triangle are to be folded onto edges f1 and f2 of the other boundary triangle respectively, then we do not have both e1 = e2 and f1 = f2.

There are in fact several other "distinctness" conditions on the edges e1, e2, f1 and f2, but they follow automatically from the "distinct vertices" condition above.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument f) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NTriangulation::collapseEdge | ( | NEdge * | e,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a collapse of an edge in such a way that the topology of the manifold does not change and the number of vertices of the triangulation decreases by one.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument e) can no longer be used.

The eligibility requirements for this move are somewhat involved, and are discussed in detail in the collapseEdge() source code for those who are interested.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge to collapse.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the given edge may be collapsed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

long regina::NTriangulation::componentIndex | ( | const NComponent * | component | ) | const

inline

Returns the index of the given component in the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getComponentIndex(). The name has been changed because, unlike the old routine, it requires that the given component belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given component belongs to this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program.

Parameters

  component | specifies which component to find in the triangulation.

Returns
  the index of the specified component, where 0 is the first component, 1 is the second and so on.

long regina::NTriangulation::connectedSumDecomposition | ( | NPacket * | primeParent = `0`,
|  | bool | setLabels = `true`
| ) |  |

Splits this triangulation into its connected sum decomposition.

The individual prime 3-manifold triangulations that make up this decomposition will be inserted as children of the given parent packet. The original triangulation will be left unchanged.

For non-orientable triangulations, this routine is only guaranteed to succeed if the original manifold contains no embedded two-sided projective planes. If the manifold does contain embedded two-sided projective planes, then this routine might still succeed but it might fail; however, such a failure will always be detected, and in such a case this routine will return -1 instead (without building any prime summands at all).

Note that this routine is currently only available for closed triangulations; see the list of preconditions for full details.

If the given parent packet is 0, the new prime summand triangulations will be inserted as children of this triangulation.

This routine can optionally assign unique (and sensible) packet labels to each of the new prime summand triangulations. Note however that uniqueness testing may be slow, so this assignment of labels should be disabled if the summand triangulations are only temporary objects used as part of a larger routine.

If this is a triangulation of a 3-sphere then no prime summand triangulations will be created at all, and this routine will return 0.

The underlying algorithm appears in "A new approach to crushing 3-manifold triangulations", Discrete and Computational Geometry 52:1 (2014), pp. 116-139. This algorithm is based on the Jaco-Rubinstein 0-efficiency algorithm, and works in both orientable and non-orientable settings.

Warning
  Users are strongly advised to check the return value if embedded two-sided projective planes are a possibility, since in such a case this routine might fail (as explained above). Note however that this routine might still succeed, and so success is not a proof that no embedded two-sided projective planes exist.
  The algorithms used in this routine rely on normal surface theory and so can be very slow for larger triangulations. For 3-sphere testing, see the routine isThreeSphere() which uses faster methods where possible.

Precondition
  This triangulation is valid, closed and connected.

Parameters

  primeParent | the packet beneath which the new prime summand triangulations will be inserted, or 0 if they should be inserted directly beneath this triangulation.
  setLabels | `true` if the new prime summand triangulations should be assigned unique packet labels, or `false` if they should be left without labels at all.

Returns
  the number of prime summands created, 0 if this triangulation is a 3-sphere, or -1 if this routine failed because this is a non-orientable triangulation with embedded two-sided projective planes.

void regina::NTriangulation::connectedSumWith | ( | const NTriangulation & | other | ) |

Forms the connected sum of this triangulation with the given triangulation.

This triangulation will be altered directly.

If this and the given triangulation are both oriented, then the result will be oriented also, and the connected sum will respect these orientations.

This and/or the given triangulation may be bounded or ideal, or even invalid; in all cases the connected sum will be formed correctly. Note, however, that the result might possibly contain internal vertices (even if the original triangulations do not).

Precondition
  This triangulation is connected and non-empty.

Parameters

  other | the triangulation to sum with this.

std::string regina::NTriangulation::dehydrate | ( |  | ) | const

Dehydrates this triangulation into an alphabetical string.

A dehydration string is a compact text representation of a triangulation, introduced by Callahan, Hildebrand and Weeks for their cusped hyperbolic census (see below). The dehydration string of an n-tetrahedron triangulation consists of approximately (but not precisely) 5n/2 lower-case letters.

Dehydration strings come with some restrictions:

- They rely on the triangulation being "canonical" in some combinatorial sense. This is not enforced here; instead a combinatorial isomorphism is applied to make the triangulation canonical, and this isomorphic triangulation is dehydrated instead. Note that the original triangulation is not changed.
- They require the triangulation to be connected.
- They require the triangulation to have no boundary triangles (though ideal triangulations are fine).
- They can only support triangulations with at most 25 tetrahedra.

The routine rehydrate() can be used to recover a triangulation from a dehydration string. Note that the triangulation recovered might not be identical to the original, but it is guaranteed to be an isomorphic copy.

For a full description of the dehydrated triangulation format, see A Census of Cusped Hyperbolic 3-Manifolds, Callahan, Hildebrand and Weeks, Mathematics of Computation 68/225, 1999.

Returns
  a dehydrated representation of this triangulation (or an isomorphic variant of this triangulation), or the empty string if dehydration is not possible because the triangulation is disconnected, has boundary triangles or contains too many tetrahedra.

See also
  rehydrate
  insertRehydration

bool regina::NTriangulation::dependsOnParent | ( |  | ) | const

inline virtual

Determines if this packet depends upon its parent.

This is true if the parent cannot be altered without invalidating or otherwise upsetting this packet.

Returns
  `true` if and only if this packet depends on its parent.

Implements regina::NPacket.

Reimplemented in regina::NSnapPeaTriangulation.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

void regina::NTriangulation::drillEdge | ( | NEdge * | e | ) |

Drills out a regular neighbourhood of the given edge of the triangulation.

This is done by (i) performing two barycentric subdivisions, (ii) removing all tetrahedra that touch the original edge, and (iii) simplifying the resulting triangulation.

Warning
  The second barycentric subdivision will multiply the number of tetrahedra by 576; as a result this routine might be slow, and the number of tetrahedra at the end might be large (even taking the simplification into account).

Parameters

  e | the edge to drill out.

std::string regina::NTriangulation::dumpConstruction | ( |  | ) | const

Returns C++ code that can be used with insertConstruction() to reconstruct this triangulation.

The code produced will consist of the following:

- the declaration and initialisation of two integer arrays, describing the tetrahedron gluings in this trianguation;
- two additional lines that declare a new NTriangulation and call insertConstruction() to rebuild this triangulation.

The main purpose of this routine is to generate the two integer arrays, which can be tedious and error-prone to code up by hand.

Note that the number of lines of code produced grows linearly with the number of tetrahedra. If this triangulation is very large, the returned string will be very large as well.

Returns
  the C++ code that was generated.

long regina::NTriangulation::edgeIndex | ( | const NEdge * | edge | ) | const

inline

Returns the index of the given edge in the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getEdgeIndex(). The name has been changed because, unlike the old routine, it requires that the given edge belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given edge belongs to this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program.

Parameters

  edge | specifies which edge to find in the triangulation.

Returns
  the index of the specified edge, where 0 is the first edge, 1 is the second and so on.

static NTriangulation* regina::NTriangulation::enterTextTriangulation | ( | std::istream & | in,
|  | std::ostream & | out
| ) |  |

static

Allows the user to interactively enter a triangulation in plain text.

Prompts will be sent to the given output stream and information will be read from the given input stream.

Python:
  This routine is a member of class Engine. It takes no parameters; in and out are always assumed to be standard input and standard output respectively.

Parameters

  in | the input stream from which text will be read.
  out | the output stream to which prompts will be written.

Returns
  the triangulation entered in by the user.

long regina::NTriangulation::faceIndex | ( | const NTriangle * | triangle | ) | const

inline

A deprecated alias for triangleIndex().

This routine returns the index of the given triangle in the triangulation. See triangleIndex() for further details.

Deprecated:
  This routine will be removed in a future version of Regina. Please use triangleIndex() instead.

Parameters

  triangle | specifies which triangle to find in the triangulation.

Returns
  the index of the specified triangle, where 0 is the first triangle, 1 is the second and so on.

unsigned long regina::NGenericTriangulation< dim >::findAllIsomorphisms | ( | const typename DimTraits< dim >::Triangulation & | other,
|  | std::list< typename DimTraits< dim >::Isomorphism * > & | results
| ) |  | const

inherited

Finds all ways in which this triangulation is combinatorially isomorphic to the given triangulation.

This routine behaves identically to isIsomorphicTo(), except that instead of returning just one isomorphism, all such isomorphisms are returned.

See the isIsomorphicTo() notes for additional information.

The isomorphisms that are found will be inserted into the given list. These isomorphisms will be newly created, and the caller of this routine is responsible for destroying them. The given list will not be emptied before the new isomorphisms are inserted.

Python:
  Not present.

Parameters

  other | the triangulation to compare with this one.
  results | the list in which any isomorphisms found will be stored.

Returns
  the number of isomorphisms that were found.

unsigned long regina::NGenericTriangulation< dim >::findAllSubcomplexesIn | ( | const typename DimTraits< dim >::Triangulation & | other,
|  | std::list< typename DimTraits< dim >::Isomorphism * > & | results
| ) |  | const

inherited

Finds all ways in which an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components).

This routine behaves identically to isContainedIn(), except that instead of returning just one isomorphism (which may be boundary incomplete and need not be onto), all such isomorphisms are returned.

See the isContainedIn() notes for additional information.

The isomorphisms that are found will be inserted into the given list. These isomorphisms will be newly created, and the caller of this routine is responsible for destroying them. The given list will not be emptied before the new isomorphisms are inserted.

Python:
  Not present.

Parameters

  other | the triangulation in which to search for isomorphic copies of this triangulation.
  results | the list in which any isomorphisms found will be stored.

Returns
  the number of isomorphisms that were found.

NPacket* regina::NPacket::findPacketLabel | ( | const std::string & | label | ) |

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

const NPacket* regina::NPacket::findPacketLabel | ( | const std::string & | label | ) | const

inherited

Finds the packet with the requested label in the tree or subtree for which this packet is matriarch.

Note that label comparisons are case sensitive.

Parameters

  label | the label to search for.

Returns
  the packet with the requested label, or 0 if there is no such packet.

const NAngleStructure* regina::NTriangulation::findStrictAngleStructure | ( |  | ) | const

Searches for a strict angle structure on this triangulation.

Recall that a strict angle structure is one in which every angle is strictly between 0 and π. If a strict angle structure does exist, then this routine is guaranteed to find one.

The underlying algorithm runs a single linear program (it does not enumerate all vertex angle structures). This means that it is likely to be fast even for large triangulations.

If you are only interested in whether a strict angle structure exists (i.e., you are not interested in the specific angles themselves), then you may call hasStrictAngleStructure() instead.

The angle structure returned (if any) is cached internally alongside this triangulation. This means that, as long as the triangulation does not change, subsequent calls to findStrictAngleStructure() will return identical pointers and will be essentially instantaneous.

If the triangulation changes however, then the cached angle structure will be deleted. This means that you should not store the returned pointer for later use; instead you should just call findStrictAngleStructure() again.

Returns
  a strict angle structure on this triangulation, or 0 if none exists.

bool regina::NTriangulation::finiteToIdeal | ( |  | ) |

Converts each real boundary component into a cusp (i.e., an ideal vertex).

Only boundary components formed from real tetrahedron faces will be affected; ideal boundary components are already cusps and so will not be changed.

One side-effect of this operation is that all spherical boundary components will be filled in with balls.

This operation is performed by attaching a new tetrahedron to each boundary triangle and then gluing these new tetrahedra together in a way that mirrors the adjacencies of the underlying boundary triangles. Each boundary component will thereby be pushed up through the new tetrahedra and converted into a cusp formed using vertices of these new tetrahedra.

Note that this operation is a loose converse of idealToFinite().

Warning
  If a real boundary component contains vertices whose links are not discs, this operation may have unexpected results.

Returns
  `true` if changes were made, or `false` if the original triangulation contained no real boundary components.

NPacket* regina::NPacket::firstTreePacket | ( | const std::string & | type | ) |

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

const NPacket* regina::NPacket::firstTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the first packet of the requested type in a complete depth-first iteration of the tree structure.

Note that this packet must be the matriarch of the entire tree.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the first such packet, or 0 if there are no packets of the requested type.

bool regina::NTriangulation::fourFourMove | ( | NEdge * | e,
|  | int | newAxis,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 4-4 move about the given edge.

This involves replacing the four tetrahedra joined at that edge with four tetrahedra joined along a different edge. Consider the octahedron made up of the four original tetrahedra; this has three internal axes. The initial four tetrahedra meet along the given edge which forms one of these axes; the new tetrahedra will meet along a different axis. This move can be done iff (i) the edge is valid and non-boundary, and (ii) the four tetrahedra are distinct.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument e) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge about which to perform the move.

  newAxis

  Specifies which axis of the octahedron the new tetrahedra should meet along; this should be 0 or 1. Consider the four original tetrahedra in the order described by NEdge::getEmbeddings(); call these tetrahedra 0, 1, 2 and
  1. If newAxis is 0, the new axis will separate tetrahedra 0 and 1 from 2 and 3. If newAxis is 1, the new axis will separate tetrahedra 1 and 2 from 3 and 0.

  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

static DimTraits<dim>::Triangulation* regina::NGenericTriangulation< dim >::fromIsoSig | ( | const std::string & | sig | ) |

static inherited

Recovers a full triangulation from an isomorphism signature.

See isoSig() for more information on isomorphism signatures. It will be assumed that the signature describes a triangulation of dimension dim.

The triangulation that is returned will be newly created.

Calling isoSig() followed by fromIsoSig() is not guaranteed to produce an identical triangulation to the original, but it is guaranteed to produce a combinatorially isomorphic triangulation.

For a full and precise description of the isomorphism signature format for 3-manifold triangulations, see Simplification paths in the Pachner graphs of closed orientable 3-manifold triangulations, Burton, 2011, `arXiv:1110.6080`. The format for other dimensions is essentially the same, but with minor dimension-specific adjustments.

Warning
  Do not mix isomorphism signatures between dimensions! It is possible that the same string could corresponding to both a p-dimensional triangulation and a q-dimensional triangulation for different p and q.

Parameters

  sig | the isomorphism signature of the triangulation to construct. Note that, unlike dehydration strings for 3-manifold triangulations, case is important for isomorphism signatures.

Returns
  a newly allocated triangulation if the reconstruction was successful, or null if the given string was not a valid isomorphism signature.

static NTriangulation* regina::NTriangulation::fromSnapPea | ( | const std::string & | snapPeaData | ) |

static

Extracts the tetrahedron gluings from a string that contains the full contents of a SnapPea data file.

All other SnapPea-specific information (such as peripheral curves) will be ignored, since Regina's NTriangulation class does not track such information itself.

If you wish to preserve all SnapPea-specific information from the data file, you should work with the NSnapPeaTriangulation class instead (which uses the SnapPea kernel directly, and can therefore store anything that SnapPea can).

If you wish to read a triangulation from a SnapPea file, you should likewise call the NSnapPeaTriangulation constructor, giving the filename as argument. This will read all SnapPea-specific information (as described above), and also avoids constructing an enormous intermediate string.

The triangulation that is returned will be newly created. If the SnapPea data is not in the correct format, this routine will return 0 instead.

Warning
  This routine is "lossy", in that drops SnapPea-specific information (as described above). Unless you specifically need an NTriangulation (not an NSnapPeaTriangulation) or you need to avoid calling routines from the SnapPea kernel, it is highly recommended that you create an NSnapPeaTriangulation from the given file contents instead. See the string-based NSnapPeaTriangulation constructor for how to do this.

Parameters

  snapPeaData | a string containing the full contents of a SnapPea data file.

Returns
  a new triangulation extracted from the given data, or 0 on error.

NBoundaryComponent * regina::NTriangulation::getBoundaryComponent | ( | unsigned long | index | ) | const

inline

Returns the requested triangulation boundary component.

Bear in mind that each time the triangulation changes, the boundary components will be deleted and replaced with new ones. Thus this object should be considered temporary only.

Parameters

  index | the index of the desired boundary component, ranging from 0 to getNumberOfBoundaryComponents()-1 inclusive.

Returns
  the requested boundary component.

const std::vector< NBoundaryComponent * > & regina::NTriangulation::getBoundaryComponents | ( |  | ) | const

inline

Returns all boundary components of this triangulation.

Note that each ideal vertex forms its own boundary component.

Bear in mind that each time the triangulation changes, the boundary components will be deleted and replaced with new ones. Thus the objects contained in this list should be considered temporary only.

This reference to the list however will remain valid and up-to-date for as long as the triangulation exists.

Python:
  This routine returns a python list.

Returns
  the list of all boundary components.

NComponent * regina::NTriangulation::getComponent | ( | unsigned long | index | ) | const

inline

Returns the requested triangulation component.

Bear in mind that each time the triangulation changes, the components will be deleted and replaced with new ones. Thus this object should be considered temporary only.

Parameters

  index | the index of the desired component, ranging from 0 to getNumberOfComponents()-1 inclusive.

Returns
  the requested component.

const std::vector< NComponent * > & regina::NTriangulation::getComponents | ( |  | ) | const

inline

Returns all components of this triangulation.

Bear in mind that each time the triangulation changes, the components will be deleted and replaced with new ones. Thus the objects contained in this list should be considered temporary only.

This reference to the list however will remain valid and up-to-date for as long as the triangulation exists.

Python:
  This routine returns a python list.

Returns
  the list of all components.

NEdge * regina::NTriangulation::getEdge | ( | unsigned long | index | ) | const

inline

Returns the requested edge in this triangulation.

Bear in mind that each time the triangulation changes, the edges will be deleted and replaced with new ones. Thus this object should be considered temporary only.

Parameters

  index | the index of the desired edge, ranging from 0 to getNumberOfEdges()-1 inclusive.

Returns
  the requested edge.

const std::vector< NEdge * > & regina::NTriangulation::getEdges | ( |  | ) | const

inline

Returns all edges of this triangulation.

Bear in mind that each time the triangulation changes, the edges will be deleted and replaced with new ones. Thus the objects contained in this list should be considered temporary only.

This reference to the list however will remain valid and up-to-date for as long as the triangulation exists.

Python:
  This routine returns a python list.

Returns
  the list of all edges.

long regina::NTriangulation::getEulerCharacteristic | ( |  | ) | const

inline

A deprecated alias for getEulerCharTri().

This routine calculates the Euler characteristic of this triangulation. Since it treats cusps in a non-standard way, it was renamed to getEulerCharTri() in Regina 4.4 to clarify that this might differ from the Euler characteristic of the corresponding compact manifold.

See getEulerCharTri() for further details.

Deprecated:
  This routine will be removed in a future version of Regina. Please use getEulerCharTri() instead.

Returns
  the Euler characteristic of this triangulation.

long regina::NTriangulation::getEulerCharManifold | ( |  | ) | const

Returns the Euler characteristic of the corresponding compact 3-manifold.

Instead of simply calculating V-E+F-T, this routine also:

- treats ideal vertices as surface boundary components (i.e., effectively truncates them);
- truncates invalid boundary vertices (i.e., boundary vertices whose links are not discs);
- truncates the projective plane cusps at the midpoints of invalid edges (edges identified with themselves in reverse).

For ideal triangulations, this routine therefore computes the proper Euler characteristic of the manifold (unlike getEulerCharTri(), which does not).

For triangulations whose vertex links are all spheres or discs, this routine and getEulerCharTri() give identical results.

Returns
  the Euler characteristic of the corresponding compact manifold.

long regina::NTriangulation::getEulerCharTri | ( |  | ) | const

inline

Returns the Euler characteristic of this triangulation.

This will be evaluated strictly as V-E+F-T.

Note that this routine handles cusps in a non-standard way. Since it computes the Euler characteristic of the triangulation (and not the underlying manifold), this routine will treat each cusp as a single vertex, and not as a surface boundary component.

For a routine that handles cusps properly (i.e., treats them as surface boundary components when computing the Euler characteristic), see getEulerCharManifold() instead.

This routine was previously called getEulerCharacteristic() in Regina 4.3.1 and earlier. It was renamed in Regina 4.4 to clarify the non-standard handling of cusps.

Returns
  the Euler characteristic of this triangulation.

NTriangle * regina::NTriangulation::getFace | ( | unsigned long | index | ) | const

inline

A deprecated alias for getTriangle().

This routine returns the requested triangular face in the triangulation. See getTriangle() for further details.

Deprecated:
  This routine will be removed in a future version of Regina. Please use getTriangle() instead.

Parameters

  index | the index of the desired triangle, ranging from 0 to getNumberOfTriangles()-1 inclusive.

Returns
  the requested triangle.

const std::vector< NTriangle * > & regina::NTriangulation::getFaces | ( |  | ) | const

inline

A deprecated alias for getTriangles().

This routine returns all triangular faces in this triangulation. See getTriangles() for further details.

Deprecated:
  This routine will be removed in a future version of Regina. Please use getTriangles() instead.

Returns
  the list of all triangles.

NPacket * regina::NPacket::getFirstTreeChild | ( |  | ) | const

inline inherited

Determines the first child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the first child packet, or 0 if there is none.

std::string regina::NPacket::getFullName | ( |  | ) | const

inherited

Returns a descriptive text string for the packet.

The string is of the form label (packet-type).

The packet label will be adjusted for human-readable output according to the behaviour of getHumanLabel().

Returns
  the descriptive text string.

const NGroupPresentation& regina::NTriangulation::getFundamentalGroup | ( |  | ) | const

Returns the fundamental group of this triangulation.

If this triangulation contains any ideal or non-standard vertices, the fundamental group will be calculated as if each such vertex had been truncated.

If this triangulation contains any invalid edges, the calculations will be performed without any truncation of the corresponding projective plane cusp. Thus if a barycentric subdivision is performed on the triangulation, the result of getFundamentalGroup() will change.

Bear in mind that each time the triangulation changes, the fundamental group will be deleted. Thus the reference that is returned from this routine should not be kept for later use. Instead, getFundamentalGroup() should be called again; this will be instantaneous if the group has already been calculated.

Note that this triangulation is not required to be valid (see isValid()).

Precondition
  This triangulation has at most one component.

Warning
  As with every routine implemented by Regina's NTriangulation class, if you are calling this from the subclass NSnapPeaTriangulation then any fillings on the cusps will be ignored. If you wish to compute the fundamental group with fillings, call NSnapPeaTriangulation::fundamentalGroupFilled() instead.

Returns
  the fundamental group.

const NAbelianGroup& regina::NTriangulation::getHomologyH1 | ( |  | ) | const

Returns the first homology group for this triangulation.

If this triangulation contains any ideal or non-standard vertices, the homology group will be calculated as if each such vertex had been truncated.

If this triangulation contains any invalid edges, the calculations will be performed without any truncation of the corresponding projective plane cusp. Thus if a barycentric subdivision is performed on the triangulation, the result of getHomologyH1() will change.

Bear in mind that each time the triangulation changes, the homology groups will be deleted. Thus the reference that is returned from this routine should not be kept for later use. Instead, getHomologyH1() should be called again; this will be instantaneous if the group has already been calculated.

Note that this triangulation is not required to be valid (see isValid()).

Warning
  As with every routine implemented by Regina's NTriangulation class, if you are calling this from the subclass NSnapPeaTriangulation then any fillings on the cusps will be ignored. If you wish to compute homology with fillings, call NSnapPeaTriangulation::homologyFilled() instead.

Returns
  the first homology group.

const NAbelianGroup& regina::NTriangulation::getHomologyH1Bdry | ( |  | ) | const

Returns the first homology group of the boundary for this triangulation.

Note that ideal vertices are considered part of the boundary.

Bear in mind that each time the triangulation changes, the homology groups will be deleted. Thus the reference that is returned from this routine should not be kept for later use. Instead, getHomologyH1Bdry() should be called again; this will be instantaneous if the group has already been calculated.

This routine is fairly fast, since it deduces the homology of each boundary component through knowing what kind of surface it is.

Precondition
  This triangulation is valid.

Returns
  the first homology group of the boundary.

const NAbelianGroup& regina::NTriangulation::getHomologyH1Rel | ( |  | ) | const

Returns the relative first homology group with respect to the boundary for this triangulation.

Note that ideal vertices are considered part of the boundary.

Bear in mind that each time the triangulation changes, the homology groups will be deleted. Thus the reference that is returned from this routine should not be kept for later use. Instead, getHomologyH1Rel() should be called again; this will be instantaneous if the group has already been calculated.

Precondition
  This triangulation is valid.

Returns
  the relative first homology group with respect to the boundary.

const NAbelianGroup& regina::NTriangulation::getHomologyH2 | ( |  | ) | const

Returns the second homology group for this triangulation.

If this triangulation contains any ideal vertices, the homology group will be calculated as if each such vertex had been truncated. The algorithm used calculates various first homology groups and uses homology and cohomology theorems to deduce the second homology group.

Bear in mind that each time the triangulation changes, the homology groups will be deleted. Thus the reference that is returned from this routine should not be kept for later use. Instead, getHomologyH2() should be called again; this will be instantaneous if the group has already been calculated.

Precondition
  This triangulation is valid.

Returns
  the second homology group.

unsigned long regina::NTriangulation::getHomologyH2Z2 | ( |  | ) | const

inline

Returns the second homology group with coefficients in Z_2 for this triangulation.

If this triangulation contains any ideal vertices, the homology group will be calculated as if each such vertex had been truncated. The algorithm used calculates the relative first homology group with respect to the boundary and uses homology and cohomology theorems to deduce the second homology group.

This group will simply be the direct sum of several copies of Z_2, so the number of Z_2 terms is returned.

Precondition
  This triangulation is valid.

Returns
  the number of Z_2 terms in the second homology group with coefficients in Z_2.

std::string regina::NPacket::getHumanLabel | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet, adjusted if necessary for human-readable output.

In particular, if the packet has no label assigned then this routine will return "(no label)", not the empty string.

Warning
  The method by which this routine adjusts packet labels is subject to change in future versions of Regina.

Returns
  this individual packet's label.

NPacket * regina::NPacket::getLastTreeChild | ( |  | ) | const

inline inherited

Determines the last child of this packet in the tree structure.

This routine takes small constant time.

Returns
  the last child packet, or 0 if there is none.

NPacket * regina::NPacket::getNextTreeSibling | ( |  | ) | const

inline inherited

Determines the next sibling of this packet in the tree structure.

This is the child of the parent that follows this packet.

This routine takes small constant time.

Returns
  the next sibling of this packet, or 0 if there is none.

unsigned long regina::NTriangulation::getNumberOfBoundaryComponents | ( |  | ) | const

inline

Returns the number of boundary components in this triangulation.

Note that each ideal vertex forms its own boundary component.

Returns
  the number of boundary components.

unsigned long regina::NTriangulation::getNumberOfBoundaryTriangles | ( |  | ) | const

inline

Returns the number of boundary triangles in this triangulation.

Returns
  the total number of boundary triangles.

unsigned long regina::NPacket::getNumberOfChildren | ( |  | ) | const

inherited

Returns the number of immediate children of this packet.

Grandchildren and so on are not counted.

Returns
  the number of immediate children.

unsigned long regina::NTriangulation::getNumberOfComponents | ( |  | ) | const

inline

Returns the number of components in this triangulation.

Returns
  the number of components.

unsigned long regina::NPacket::getNumberOfDescendants | ( |  | ) | const

inline inherited

Returns the total number of descendants of this packet.

This includes children, grandchildren and so on. This packet is not included in the count.

Returns
  the total number of descendants.

unsigned long regina::NTriangulation::getNumberOfEdges | ( |  | ) | const

inline

Returns the number of edges in this triangulation.

Returns
  the number of edges.

unsigned long regina::NTriangulation::getNumberOfFaces | ( |  | ) | const

inline

A deprecated alias for getNumberOfTriangles().

This routine returns the number of triangular faces in this triangulation. See getNumberOfTriangles() for further details.

Do not confuse this deprecated alias with the (non-deprecated) tempate function getNumberOfFaces<dim>().

Deprecated:
  This routine will be removed in a future version of Regina. Please use getNumberOfTriangles() instead.

Returns
  the number of triangles.

template<int dim>

unsigned long regina::NTriangulation::getNumberOfFaces | ( |  | ) | const

Returns the number of faces of the given dimension in this triangulation.

This template function is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Precondition
  the template argument dim is between 0 and 3 inclusive.

Python:
  Not present.

Returns
  the number of faces of the given dimension.

unsigned long regina::NTriangulation::getNumberOfSimplices | ( |  | ) | const

inline

A dimension-agnostic alias for getNumberOfTetrahedra().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See getNumberOfTetrahedra() for further information.

unsigned long regina::NTriangulation::getNumberOfTetrahedra | ( |  | ) | const

inline

Returns the number of tetrahedra in the triangulation.

Returns
  the number of tetrahedra.

unsigned long regina::NTriangulation::getNumberOfTriangles | ( |  | ) | const

inline

Returns the number of triangular faces in this triangulation.

Returns
  the number of triangles.

unsigned long regina::NTriangulation::getNumberOfVertices | ( |  | ) | const

inline

Returns the number of vertices in this triangulation.

Returns
  the number of vertices.

const std::string & regina::NPacket::getPacketLabel | ( |  | ) | const

inline inherited

Returns the label associated with this individual packet.

An example is `MyTriangulation`. Each individual packet in the overall tree structure must have a unique label.

Returns
  this individual packet's label.

virtual PacketType regina::NPacket::getPacketType | ( |  | ) | const

pure virtual inherited

Returns the unique integer ID representing this type of packet.

This is the same for all packets of this class.

Returns
  the packet type ID.

virtual std::string regina::NPacket::getPacketTypeName | ( |  | ) | const

pure virtual inherited

Returns an English name for this type of packet.

An example is `NTriangulation`. This is the same for all packets of this class.

Returns
  the packet type name.

NPacket * regina::NPacket::getPrevTreeSibling | ( |  | ) | const

inline inherited

Determines the previous sibling of this packet in the tree structure.

This is the child of the parent that precedes this packet.

This routine takes small constant time.

Returns
  the previous sibling of this packet, or 0 if there is none.

NTetrahedron * regina::NTriangulation::getSimplex | ( | unsigned long | index | ) |

inline

A dimension-agnostic alias for getTetrahedron().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See getTetrahedron() for further information.

const NTetrahedron * regina::NTriangulation::getSimplex | ( | unsigned long | index | ) | const

inline

A dimension-agnostic alias for getTetrahedron().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See getTetrahedron() for further information.

const std::vector< NTetrahedron * > & regina::NTriangulation::getSimplices | ( |  | ) | const

inline

A dimension-agnostic alias for getTetrahedra().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See getTetrahedra() for further information.

const std::set< std::string > & regina::NPacket::getTags | ( |  | ) | const

inline inherited

Returns the set of all tags associated with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Python:
  This routine returns a python list of strings.

Returns
  the set of all tags associated with this packet.

const std::vector< NTetrahedron * > & regina::NTriangulation::getTetrahedra | ( |  | ) | const

inline

Returns all tetrahedra in the triangulation.

The reference returned will remain valid for as long as the triangulation exists, always reflecting the tetrahedra currently in the triangulation.

Python:
  This routine returns a python list.

Returns
  the list of all tetrahedra.

NTetrahedron * regina::NTriangulation::getTetrahedron | ( | unsigned long | index | ) |

inline

Returns the tetrahedron with the given index number in the triangulation.

Note that tetrahedron indexing may change when a tetrahedron is added or removed from the triangulation.

Parameters

  index | specifies which tetrahedron to return; this value should be between 0 and getNumberOfTetrahedra()-1 inclusive.

Returns
  the `index`th tetrahedron in the triangulation.

const NTetrahedron * regina::NTriangulation::getTetrahedron | ( | unsigned long | index | ) | const

inline

Returns the tetrahedron with the given index number in the triangulation.

Note that tetrahedron indexing may change when a tetrahedron is added or removed from the triangulation.

Parameters

  index | specifies which tetrahedron to return; this value should be between 0 and getNumberOfTetrahedra()-1 inclusive.

Returns
  the `index`th tetrahedron in the triangulation.

unsigned long regina::NPacket::getTotalTreeSize | ( |  | ) | const

inherited

Determines the total number of packets in the tree or subtree for which this packet is matriarch.

This packet is included in the count.

Returns
  the total tree or subtree size.

NPacket* regina::NPacket::getTreeMatriarch | ( |  | ) | const

inherited

Determines the matriarch (the root) of the tree to which this packet belongs.

Returns
  the matriarch of the packet tree.

NPacket * regina::NPacket::getTreeParent | ( |  | ) | const

inline inherited

Determines the parent packet in the tree structure.

This routine takes small constant time.

Returns
  the parent packet, or 0 if there is none.

NTriangle * regina::NTriangulation::getTriangle | ( | unsigned long | index | ) | const

inline

Returns the requested triangular face in this triangulation.

Bear in mind that each time the triangulation changes, the triangles will be deleted and replaced with new ones. Thus this object should be considered temporary only.

Parameters

  index | the index of the desired triangle, ranging from 0 to getNumberOfTriangles()-1 inclusive.

Returns
  the requested triangle.

const std::vector< NTriangle * > & regina::NTriangulation::getTriangles | ( |  | ) | const

inline

Returns all triangular faces of this triangulation.

Bear in mind that each time the triangulation changes, the triangles will be deleted and replaced with new ones. Thus the objects contained in this list should be considered temporary only.

This reference to the list however will remain valid and up-to-date for as long as the triangulation exists.

Python:
  This routine returns a python list.

Returns
  the list of all triangles.

NVertex * regina::NTriangulation::getVertex | ( | unsigned long | index | ) | const

inline

Returns the requested vertex in this triangulation.

Bear in mind that each time the triangulation changes, the vertices will be deleted and replaced with new ones. Thus this object should be considered temporary only.

Parameters

  index | the index of the desired vertex, ranging from 0 to getNumberOfVertices()-1 inclusive.

Returns
  the requested vertex.

const std::vector< NVertex * > & regina::NTriangulation::getVertices | ( |  | ) | const

inline

Returns all vertices of this triangulation.

Bear in mind that each time the triangulation changes, the vertices will be deleted and replaced with new ones. Thus the objects contained in this list should be considered temporary only.

This reference to the list however will remain valid and up-to-date for as long as the triangulation exists.

Python:
  This routine returns a python list.

Returns
  the list of all vertices.

void regina::NTriangulation::gluingsHaveChanged | ( |  | ) |

inline

This routine now does nothing, and should not be used.

Deprecated:
  In Regina versions 4.6 and earlier, this routine was used to manually notify the triangulation that the gluings of tetrahedra had changed. In Regina 4.90 and later this notification is automatic. This routine now does nothing at all, and can safely be removed from any existing code.

bool regina::NTriangulation::hasBoundaryFaces | ( |  | ) | const

inline

A deprecated alias for hasBoundaryTriangles().

This routine determines whether this triangulation has any boundary triangles. See hasBoundaryTriangles() for further details.

Deprecated:
  This routine will be removed in a future version of Regina. Please use hasBoundaryTriangles() instead.

Returns
  `true` if and only if there are boundary triangles.

bool regina::NTriangulation::hasBoundaryTriangles | ( |  | ) | const

inline

Determines if this triangulation has any boundary triangles.

Returns
  `true` if and only if there are boundary triangles.

bool regina::NTriangulation::hasCompressingDisc | ( |  | ) | const

Searches for a compressing disc within the underlying 3-manifold.

Let M be the underlying 3-manifold and let B be its boundary. By a compressing disc, we mean a disc D properly embedded in M, where the boundary of D lies in B but does not bound a disc in B.

This routine will first call the heuristic routine hasSimpleCompressingDisc() in the hope of obtaining a fast answer. If this fails, it will do one of two things:

- If the triangulation is orientable and 1-vertex, it will use the linear programming and crushing machinery outlined in "Computing closed essential surfaces in knot complements", Burton, Coward and Tillmann, SCG '13, p405-414, 2013. This is often extremely fast, even for triangulations with many tetrahedra.
- If the triangulation is non-orientable or has multiple vertices then it will run a full enumeration of vertex normal surfaces, as described in "Algorithms for the complete decomposition of a closed 3-manifold", Jaco and Tollefson, Illinois J. Math. 39 (1995), 358-406. As the number of tetrahedra grows, this can become extremely slow.

This routine will work on a copy of this triangulation, not the original. In particular, the copy will be simplified, which means that there is no harm in calling this routine on an unsimplified triangulation.

If this triangulation has no boundary components, this routine will simply return `false`.

Precondition
  This triangulation is valid and is not ideal.
  The underlying 3-manifold is irreducible.

Warning
  This routine can be infeasibly slow for large triangulations (particularly those that are non-orientable or have multiple vertices), since it may need to perform a full enumeration of vertex normal surfaces, and since it might perform "large" operations on these surfaces such as cutting along them. See hasSimpleCompressingDisc() for a "heuristic shortcut" that is faster but might not give a definitive answer.

Returns
  `true` if the underlying 3-manifold contains a compressing disc, or `false` if it does not.

bool regina::NTriangulation::hasNegativeIdealBoundaryComponents | ( |  | ) | const

inline

Determines if this triangulation contains any ideal boundary components with negative Euler characteristic.

Returns
  `true` if and only if there is at least one such boundary component.

NNormalSurface* regina::NTriangulation::hasNonTrivialSphereOrDisc | ( |  | ) |

Searches for a non-vertex-linking normal sphere or disc within this triangulation.

If such a surface exists within this triangulation, this routine is guaranteed to find one.

Note that the surface returned (if any) depends upon this triangulation, and so the surface must be destroyed before this triangulation is destroyed.

Warning
  This routine may, in some scenarios, temporarily modify the packet tree by creating and then destroying a normal surface list.

Returns
  a newly allocated non-vertex-linking normal sphere or disc, or 0 if none exists.

NNormalSurface* regina::NTriangulation::hasOctagonalAlmostNormalSphere | ( |  | ) |

Searches for an octagonal almost normal 2-sphere within this triangulation.

If such a surface exists, this routine is guaranteed to find one.

Note that the surface returned (if any) depends upon this triangulation, and so the surface must be destroyed before this triangulation is destroyed.

Precondition
  This triangulation is valid, closed, orientable, connected, and 0-efficient. These preconditions are almost certainly more restrictive than they need to be, but we stay safe for now.

Warning
  This routine may, in some scenarios, temporarily modify the packet tree by creating and then destroying a normal surface list.

Returns
  a newly allocated non-vertex-linking normal sphere or disc, or 0 if none exists.

bool regina::NTriangulation::hasSimpleCompressingDisc | ( |  | ) | const

Searches for a "simple" compressing disc inside this triangulation.

Let M be the underlying 3-manifold and let B be its boundary. By a compressing disc, we mean a disc D properly embedded in M, where the boundary of D lies in B but does not bound a disc in B.

By a simple compressing disc, we mean a compressing disc that has a very simple combinatorial structure (here "simple" is subject to change; see the warning below). Examples include the compressing disc inside a 1-tetrahedron solid torus, or a compressing disc formed from a single internal triangle surrounded by three boundary edges.

The purpose of this routine is to avoid working with normal surfaces within a large triangulation where possible. This routine is relatively fast, and if it returns `true` then this 3-manifold definitely contains a compressing disc. If this routine returns `false` then there might or might not be a compressing disc; the user will need to perform a full normal surface enumeration using hasCompressingDisc() to be sure.

This routine will work on a copy of this triangulation, not the original. In particular, the copy will be simplified, which means that there is no harm in calling this routine on an unsimplified triangulation.

If this triangulation has no boundary components, this routine will simply return `false`.

For further information on this test, see "The Weber-Seifert dodecahedral space is non-Haken", Benjamin A. Burton, J. Hyam Rubinstein and Stephan Tillmann, Trans. Amer. Math. Soc. 364:2 (2012), pp. 911-932.

Warning
  The definition of "simple" is subject to change in future releases of Regina. That is, this routine may be expanded over time to identify more types of compressing discs (thus making it more useful as a "heuristic shortcut").

Precondition
  This triangulation is valid and is not ideal.

Returns
  `true` if a simple compressing disc was found, or `false` if not. Note that even with a return value of `false`, there might still be a compressing disc (just not one with a simple combinatorial structure).

bool regina::NTriangulation::hasSplittingSurface | ( |  | ) |

Determines whether this triangulation has a normal splitting surface.

See NNormalSurface::isSplitting() for details regarding normal splitting surfaces.

Precondition
  This triangulation is connected. If the triangulation is not connected, this routine will still return a result but that result will be unreliable.

Returns
  `true` if and only if this triangulation has a normal splitting surface.

bool regina::NTriangulation::hasStrictAngleStructure | ( |  | ) | const

inline

Determines whether this triangulation supports a strict angle structure.

Recall that a strict angle structure is one in which every angle is strictly between 0 and π.

This routine is equivalent to calling findStrictAngleStructure() and testing whether the return value is non-null.

The underlying algorithm runs a single linear program (it does not enumerate all vertex angle structures). This means that it is likely to be fast even for large triangulations.

Returns
  `true` if a strict angle structure exists on this triangulation, or 0 if not.

bool regina::NPacket::hasTag | ( | const std::string & | tag | ) | const

inline inherited

Determines whether this packet has the given associated tag.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to search for.

Returns
  `true` if the given tag is found, `false` otherwise.

bool regina::NPacket::hasTags | ( |  | ) | const

inline inherited

Determines whether this packet has any associated tags at all.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Returns
  `true` if this packet has any tags, `false` otherwise.

bool regina::NTriangulation::hasTwoSphereBoundaryComponents | ( |  | ) | const

inline

Determines if this triangulation contains any two-sphere boundary components.

Returns
  `true` if and only if there is at least one two-sphere boundary component.

bool regina::NTriangulation::idealToFinite | ( | bool | forceDivision = `false` | ) |

Converts an ideal triangulation into a finite triangulation.

All ideal or non-standard vertices are truncated and thus converted into real boundary components made from unglued faces of tetrahedra.

Note that this operation is a loose converse of finiteToIdeal().

Warning
  Currently, this routine subdivides all tetrahedra as if all vertices (not just some) were ideal. This may lead to more tetrahedra than are necessary.
  Currently, the presence of an invalid edge will force the triangulation to be subdivided regardless of the value of parameter forceDivision. The final triangulation will still have the projective plane cusp caused by the invalid edge.

Todo:
  Optimise (long-term): Have this routine only use as many tetrahedra as are necessary, leaving finite vertices alone.

Parameters

  forceDivision | specifies what to do if the triangulation has no ideal or non-standard vertices. If `true`, the triangulation will be subdivided anyway, as if all vertices were ideal. If `false` (the default), the triangulation will be left alone.

Returns
  `true` if and only if the triangulation was changed.

Author
  David Letscher

void regina::NTriangulation::insertAugTriSolidTorus | ( | long | a1,
|  | long | b1,
|  | long | a2,
|  | long | b2,
|  | long | a3,
|  | long | b3
| ) |  |

Inserts an augmented triangular solid torus with the given parameters into this triangulation.

Almost all augmented triangular solid tori represent Seifert fibred spaces with three or fewer exceptional fibres. Augmented triangular solid tori are described in more detail in the NAugTriSolidTorus class notes.

The resulting Seifert fibred space will be SFS((a1,b1) (a2,b2) (a3,b3) (1,1)), where the parameters a1, ..., b3 are passed as arguments to this routine. The three layered solid tori that are attached to the central triangular solid torus will be LST(|a1|, |b1|, |-a1-b1|), ..., LST(|a3|, |b3|, |-a3-b3|).

The new tetrahedra will be inserted at the end of the list of tetrahedra in the triangulation.

Precondition
  gcd(a1, b1) = 1.
  gcd(a2, b2) = 1.
  gcd(a3, b3) = 1.

Parameters

  a1 | a parameter describing the first layered solid torus in the augmented triangular solid torus; this may be either positive or negative.
  b1 | a parameter describing the first layered solid torus in the augmented triangular solid torus; this may be either positive or negative.
  a2 | a parameter describing the second layered solid torus in the augmented triangular solid torus; this may be either positive or negative.
  b2 | a parameter describing the second layered solid torus in the augmented triangular solid torus; this may be either positive or negative.
  a3 | a parameter describing the third layered solid torus in the augmented triangular solid torus; this may be either positive or negative.
  b3 | a parameter describing the third layered solid torus in the augmented triangular solid torus; this may be either positive or negative.

void regina::NPacket::insertChildAfter | ( | NPacket * | newChild,
|  | NPacket * | prevChild
| ) |  |

inherited

Inserts the given packet as a child of this packet at the given location in this packet's child list.

This routine takes small constant time.

Precondition
  Parameter newChild has no parent packet.
  Parameter prevChild is already a child of this packet.
  This packet is not a descendant of newChild.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  newChild | the child to insert.
  prevChild | the preexisting child of this packet after which newChild will be inserted, or 0 if newChild is to be the first child of this packet.

void regina::NPacket::insertChildFirst | ( | NPacket * | child | ) |

inherited

Inserts the given packet as the first child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

void regina::NPacket::insertChildLast | ( | NPacket * | child | ) |

inherited

Inserts the given packet as the last child of this packet.

This routine takes small constant time.

Precondition
  The given child has no parent packet.
  This packet is not a descendant of the given child.

Python:
  Since this packet takes ownership of the given child packet, the python object containing the given child packet becomes a null object and should no longer be used. See reparent() for a way of avoiding these problems in some cases.

Parameters

  child | the child to insert.

void regina::NTriangulation::insertConstruction | ( | unsigned long | nTetrahedra,
|  | const int | adjacencies[][4],
|  | const int | gluings[][4][4]
| ) |  |

Inserts into this triangulation a set of tetrahedra and their gluings as described by the given integer arrays.

This routine is provided to make it easy to hard-code a medium-sized triangulation in a C++ source file. All of the pertinent data can be hard-coded into a pair of integer arrays at the beginning of the source file, avoiding an otherwise tedious sequence of many joinTo() calls.

An additional nTetrahedra tetrahedra will be inserted into this triangulation. The relationships between these tetrahedra should be stored in the two arrays as follows. Note that the new tetrahedra are numbered from 0 to (nTetrahedra - 1), and individual tetrahedron faces are numbered from 0 to 3.

The adjacencies array describes which tetrahedron faces are joined to which others. Specifically, `adjacencies[t][f]` should contain the number of the tetrahedron joined to face f of tetrahedron t. If this face is to be left as a boundary triangle, `adjacencies[t][f]` should be -1.

The gluings array describes the particular gluing permutations used when joining these tetrahedron faces together. Specifically, `gluings[t][f][0..3]` should describe the permutation used to join face f of tetrahedron t to its adjacent tetrahedron. These four integers should be 0, 1, 2 and 3 in some order, so that `gluings[t][f][i]` contains the image of i under this permutation. If face f of tetrahedron t is to be left as a boundary triangle, `gluings[t][f][0..3]` may contain anything (and will be duly ignored).

It is the responsibility of the caller of this routine to ensure that the given arrays are correct and consistent. No error checking will be performed by this routine.

Note that, for an existing triangulation, dumpConstruction() will output a pair of C++ arrays that can be copied into a source file and used to reconstruct the triangulation via this routine.

Python:
  Not present.

Parameters

  nTetrahedra | the number of additional tetrahedra to insert.
  adjacencies | describes which of the new tetrahedron faces are to be identified. This array must have initial dimension at least nTetrahedra.
  gluings | describes the specific gluing permutations by which these new tetrahedron faces should be identified. This array must also have initial dimension at least nTetrahedra.

void regina::NTriangulation::insertLayeredLensSpace | ( | unsigned long | p,
|  | unsigned long | q
| ) |  |

Inserts a new layered lens space L(p,q) into the triangulation.

The lens space will be created by gluing together two layered solid tori in a way that uses the fewest possible tetrahedra.

The new tetrahedra will be inserted at the end of the list of tetrahedra in the triangulation.

Precondition
  p > q >= 0 unless (p,q) = (0,1);
  gcd(p, q) = 1.

Parameters

  p | a parameter of the desired lens space.
  q | a parameter of the desired lens space.

See also
  NLayeredLensSpace

void regina::NTriangulation::insertLayeredLoop | ( | unsigned long | length,
|  | bool | twisted
| ) |  |

Inserts a layered loop of the given length into this triangulation.

Layered loops are described in more detail in the NLayeredLoop class notes.

The new tetrahedra will be inserted at the end of the list of tetrahedra in the triangulation.

Parameters

  length | the length of the new layered loop; this must be strictly positive.
  twisted | `true` if the new layered loop should be twisted, or `false` if it should be untwisted.

See also
  NLayeredLoop

NTetrahedron* regina::NTriangulation::insertLayeredSolidTorus | ( | unsigned long | cuts0,
|  | unsigned long | cuts1
| ) |  |

Inserts a new layered solid torus into the triangulation.

The meridinal disc of the layered solid torus will intersect the three edges of the boundary torus in cuts0, cuts1 and (cuts0 + cuts1) points respectively.

The boundary torus will always consist of faces 012 and 013 of the tetrahedron containing this boundary torus (this tetrahedron will be returned). In face 012, edges 12, 02 and 01 will meet the meridinal disc cuts0, cuts1 and (cuts0 + cuts1) times respectively. The only exceptions are if these three intersection numbers are (1,1,2) or (0,1,1), in which case edges 12, 02 and 01 will meet the meridinal disc (1, 2 and 1) or (1, 1 and 0) times respectively.

The new tetrahedra will be inserted at the end of the list of tetrahedra in the triangulation.

Precondition
  0 <= cuts0 <= cuts1;
  cuts1 is non-zero;
  gcd(cuts0, cuts1) = 1.

Parameters

  cuts0 | the smallest of the three desired intersection numbers.
  cuts1 | the second smallest of the three desired intersection numbers.

Returns
  the tetrahedron containing the boundary torus.

See also
  NLayeredSolidTorus

bool regina::NTriangulation::insertRehydration | ( | const std::string & | dehydration | ) |

Inserts the rehydration of the given string into this triangulation.

If you simply wish to convert a dehydration string into a new triangulation, use the static routine rehydrate() instead. See dehydrate() for more information on dehydration strings.

This routine will first rehydrate the given string into a proper triangulation. The tetrahedra from the rehydrated triangulation will then be inserted into this triangulation in the same order in which they appear in the rehydrated triangulation, and the numbering of their vertices (0-3) will not change.

The routine dehydrate() can be used to extract a dehydration string from an existing triangulation. Dehydration followed by rehydration might not produce a triangulation identical to the original, but it is guaranteed to produce an isomorphic copy. See dehydrate() for the reasons behind this.

For a full description of the dehydrated triangulation format, see A Census of Cusped Hyperbolic 3-Manifolds, Callahan, Hildebrand and Weeks, Mathematics of Computation 68/225, 1999.

Parameters

  dehydration | a dehydrated representation of the triangulation to insert. Case is irrelevant; all letters will be treated as if they were lower case.

Returns
  `true` if the insertion was successful, or `false` if the given string could not be rehydrated.

See also
  dehydrate
  rehydrate

void regina::NTriangulation::insertSFSOverSphere | ( | long | a1 = `1`,
|  | long | b1 = `0`,
|  | long | a2 = `1`,
|  | long | b2 = `0`,
|  | long | a3 = `1`,
|  | long | b3 = `0`
| ) |  |

Inserts an orientable Seifert fibred space with at most three exceptional fibres over the 2-sphere into this triangulation.

The inserted Seifert fibred space will be SFS((a1,b1) (a2,b2) (a3,b3) (1,1)), where the parameters a1, ..., b3 are passed as arguments to this routine.

The three pairs of parameters (a,b) do not need to be normalised, i.e., the parameters can be positive or negative and b may lie outside the range [0..a). There is no separate twisting parameter; each additional twist can be incorporated into the existing parameters by replacing some pair (a,b) with the pair (a,a+b). For Seifert fibred spaces with less than three exceptional fibres, some or all of the parameter pairs may be (1,k) or even (1,0).

The new tetrahedra will be inserted at the end of the list of tetrahedra in the triangulation.

Precondition
  None of a1, a2 or a3 are 0.
  gcd(a1, b1) = 1.
  gcd(a2, b2) = 1.
  gcd(a3, b3) = 1.

Parameters

  a1 | a parameter describing the first exceptional fibre.
  b1 | a parameter describing the first exceptional fibre.
  a2 | a parameter describing the second exceptional fibre.
  b2 | a parameter describing the second exceptional fibre.
  a3 | a parameter describing the third exceptional fibre.
  b3 | a parameter describing the third exceptional fibre.

void regina::NTriangulation::insertTriangulation | ( | const NTriangulation & | source | ) |

Inserts a copy of the given triangulation into this triangulation.

The new tetrahedra will be inserted into this triangulation in the order in which they appear in the given triangulation, and the numbering of their vertices (0-3) will not change. They will be given the same descriptions as appear in the given triangulation.

Parameters

  source | the triangulation whose copy will be inserted.

bool regina::NTriangulation::intelligentSimplify | ( |  | ) |

Attempts to simplify the triangulation as intelligently as possible without further input.

This routine will attempt to reduce both the number of tetrahedra and the number of boundary triangles (with the number of tetrahedra as its priority).

Currently this routine uses simplifyToLocalMinimum() in combination with random 4-4 moves, book opening moves and book closing moves.

Warning
  The specific behaviour of this routine may well change between releases.

Todo:
  Optimise: Include random 2-3 moves to get out of wells.

Returns
  `true` if and only if the triangulation was changed.

NPacket * regina::NTriangulation::internalClonePacket | ( | NPacket * | parent | ) | const

inline protected virtual

Makes a newly allocated copy of this packet.

This routine should not insert the new packet into the tree structure, clone the packet's associated tags or give the packet a label. It should also not clone any descendants of this packet.

You may assume that the new packet will eventually be inserted into the tree beneath either the same parent as this packet or a clone of that parent.

Parameters

  parent | the parent beneath which the new packet will eventually be inserted.

Returns
  the newly allocated packet.

Implements regina::NPacket.

Reimplemented in regina::NSnapPeaTriangulation.

std::string regina::NPacket::internalID | ( |  | ) | const

inherited

Returns a unique string ID that identifies this packet.

The user has no control over this ID, and it is not human readable. It is guaranteed to remain fixed throughout the lifetime of the program for a given packet, and it is guaranteed not to clash with the ID of any other packet.

If you change the contents of a packet, its ID will not change.

If you clone a packet, the new clone will receive a different ID. If you save and then load a packet to/from file, the ID will change. These behaviours are necessary to ensure that IDs remain unique (since, for instance, you could load several copies of the same data file into memory simultaneously).

The ID is implemented as an encoding of the underlying C++ pointer. This encoding is subject to change in later versions of Regina.

Returns
  a unique ID that identifies this packet.

bool regina::NTriangulation::isBall | ( |  | ) | const

Determines whether this is a triangulation of a 3-dimensional ball.

This routine is based on isThreeSphere(), which in turn combines Rubinstein's 3-sphere recognition algorithm with Jaco and Rubinstein's 0-efficiency prime decomposition algorithm.

Warning
  The algorithms used in this routine rely on normal surface theory and so can be very slow for larger triangulations (although faster tests are used where possible). The routine knowsBall() can be called to see if this property is already known or if it happens to be very fast to calculate for this triangulation.

Returns
  `true` if and only if this is a triangulation of a 3-dimensional ball.

bool regina::NTriangulation::isClosed | ( |  | ) | const

inline

Determines if this triangulation is closed.

This is the case if and only if it has no boundary. Note that ideal triangulations are not closed.

Returns
  `true` if and only if this triangulation is closed.

bool regina::NTriangulation::isConnected | ( |  | ) | const

inline

Determines if this triangulation is connected.

Returns
  `true` if and only if this triangulation is connected.

std::auto_ptr<typename DimTraits<dim>::Isomorphism> regina::NGenericTriangulation< dim >::isContainedIn | ( | const typename DimTraits< dim >::Triangulation & | other | ) | const

inherited

Determines if an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components).

Specifically, this routine determines if there is a boundary incomplete combinatorial isomorphism from this triangulation to other. Boundary incomplete isomorphisms are described in detail in the Isomorphism class notes.

In particular, note that facets of top-dimensional simplices that lie on the boundary of this triangulation need not correspond to boundary facets of other, and that other may contain more top-dimensional simplices than this triangulation.

If a boundary incomplete isomorphism is found, the details of this isomorphism are returned. The isomorphism is newly constructed, and so to assist with memory management is returned as a std::auto_ptr. Thus, to test whether an isomorphism exists without having to explicitly deal with the isomorphism itself, you can call `if (isContainedIn(other).get())` and the newly created isomorphism (if it exists) will be automatically destroyed.

If more than one such isomorphism exists, only one will be returned. For a routine that returns all such isomorphisms, see findAllSubcomplexesIn().

Parameters

  other | the triangulation in which to search for an isomorphic copy of this triangulation.

Returns
  details of the isomorphism if such a copy is found, or a null pointer otherwise.

bool regina::NGenericTriangulation< dim >::isEmpty | ( |  | ) | const

inherited

Determines whether this triangulation is empty.

An empty triangulation is one with no simplices at all.

Returns
  `true` if and only if this triangulation is empty.

bool regina::NPacket::isGrandparentOf | ( | const NPacket * | descendant | ) | const

inherited

Determines if this packet is equal to or an ancestor of the given packet in the tree structure.

Parameters

  descendant | the other packet whose relationships we are examining.

Returns
  `true` if and only if this packet is equal to or an ancestor of `descendant`.

bool regina::NTriangulation::isHaken | ( |  | ) | const

Determines whether the underlying 3-manifold (which must be closed and orientable) is Haken.

In other words, this routine determines whether the underlying 3-manifold contains an embedded closed two-sided incompressible surface.

Currently Hakenness testing is available only for irreducible manifolds. This routine will first test whether the manifold is irreducible and, if it is not, will return `false` immediately.

Precondition
  This triangulation is valid, closed, orientable and connected.

Warning
  This routine could be very slow for larger triangulations.

Returns
  `true` if and only if the underlying 3-manifold is irreducible and Haken.

bool regina::NTriangulation::isIdeal | ( |  | ) | const

inline

Determines if this triangulation is ideal.

This is the case if and only if one of the vertex links is closed and not a 2-sphere. Note that the triangulation is not required to be valid.

Returns
  `true` if and only if this triangulation is ideal.

bool regina::NGenericTriangulation< dim >::isIdenticalTo | ( | const typename DimTraits< dim >::Triangulation & | other | ) | const

inherited

Determines if this triangulation is combinatorially identical to the given triangulation.

Here "identical" means that the triangulations have the same number of top-dimensional simplices, with gluings between the same pairs of numbered simplices using the same gluing permutations. In other words, "identical" means that the triangulations are isomorphic via the identity isomorphism.

To test for the less strict combinatorial isomorphism (which allows relabelling of the top-dimensional simplices and their vertices), see isIsomorphicTo() instead.

This test does not examine the textual simplex descriptions, as seen in Simplex::getDescription(); these may still differ. It also does not test the numbering of vertices, edges and so on, as used by getVertex(), getEdge() and so on; although at the time of writing these will always be numbered the same for identical triangulations, it is conceivable that in future versions of Regina there may be situations in which identical triangulations can acquire different numberings for vertices, edges, etc.

Parameters

  other | the triangulation to compare with this one.

Returns
  `true` if and only if the two triangulations are combinatorially identical.

bool regina::NTriangulation::isIrreducible | ( |  | ) | const

Determines whether the underlying 3-manifold (which must be closed) is irreducible.

In other words, this routine determines whether every embedded sphere in the underlying 3-manifold bounds a ball.

If the underlying 3-manifold is orientable, this routine will use fast crushing and branch-and-bound methods. If the underlying 3-manifold is non-orientable, it will use a (much slower) full enumeration of vertex normal surfaces.

Warning
  The algorithms used in this routine rely on normal surface theory and might be slow for larger triangulations.

Precondition
  This triangulation is valid, closed, orientable and connected.

Returns
  `true` if and only if the underlying 3-manifold is irreducible.

std::auto_ptr<typename DimTraits<dim>::Isomorphism> regina::NGenericTriangulation< dim >::isIsomorphicTo | ( | const typename DimTraits< dim >::Triangulation & | other | ) | const

inherited

Determines if this triangulation is combinatorially isomorphic to the given triangulation.

Specifically, this routine determines if there is a one-to-one and onto boundary complete combinatorial isomorphism from this triangulation to other. Boundary complete isomorphisms are described in detail in the Isomorphism class notes.

In particular, note that this triangulation and other must contain the same number of top-dimensional simplices for such an isomorphism to exist.

If you need to ensure that top-dimensional simplices are labelled the same in both triangulations, see the stricter test isIdenticalTo() instead.

If a boundary complete isomorphism is found, the details of this isomorphism are returned. The isomorphism is newly constructed, and so to assist with memory management is returned as a std::auto_ptr. Thus, to test whether an isomorphism exists without having to explicitly deal with the isomorphism itself, you can call `if (isIsomorphicTo(other).get())` and the newly created isomorphism (if it exists) will be automatically destroyed.

If more than one such isomorphism exists, only one will be returned. For a routine that returns all such isomorphisms, see findAllIsomorphisms().

Todo:
  Optimise: Improve the complexity by choosing a simplex mapping from each component and following gluings to determine the others.

Parameters

  other | the triangulation to compare with this one.

Returns
  details of the isomorphism if the two triangulations are combinatorially isomorphic, or a null pointer otherwise.

bool regina::NPacket::isListening | ( | NPacketListener * | listener | ) |

inline inherited

Determines whether the given packet listener is currently listening for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to search for.

Returns
  `true` if the given listener is currently registered with this packet, or `false` otherwise.

bool regina::NTriangulation::isOrdered | ( |  | ) | const

Determines if this triangulation is ordered; that is, if tetrahedron vertices are labelled so that all gluing permutations are order-preserving on the tetrahedron faces.

Equivalently, this tests whether the edges of the triangulation can all be oriented such that they induce a consistent ordering on the vertices of each tetrahedron.

Triangulations are not ordered by default, and indeed some cannot be ordered at all. The routine order() will attempt to relabel tetrahedron vertices to give an ordered triangulation.

Returns
  `true` if and only if all gluing permutations are order preserving on the tetrahedron faces.

Author
  Matthias Goerner

bool regina::NTriangulation::isOrientable | ( |  | ) | const

inline

Determines if this triangulation is orientable.

Returns
  `true` if and only if this triangulation is orientable.

bool regina::NTriangulation::isOriented | ( |  | ) | const

Determines if this triangulation is oriented; that is, if tetrahedron vertices are labelled in a way that preserves orientation across adjacent tetrahedron faces.

Specifically, this routine returns `true` if and only if every gluing permutation has negative sign.

Note that orientable triangulations are not always oriented by default. You can call orient() if you need the tetrahedra to be oriented consistently as described above.

A non-orientable triangulation can never be oriented.

Returns
  `true` if and only if all tetrahedra are oriented consistently.

Author
  Matthias Goerner

std::string regina::NGenericTriangulation< dim >::isoSig | ( | typename DimTraits< dim >::Isomorphism ** | relabelling = `0` | ) | const

inherited

Constructs the isomorphism signature for this triangulation.

An isomorphism signature is a compact text representation of a triangulation. Unlike dehydrations for 3-manifold triangulations, an isomorphism signature uniquely determines a triangulation up to combinatorial isomorphism (assuming the dimension is known in advance). That is, two triangulations of dimension dim are combinatorially isomorphic if and only if their isomorphism signatures are the same.

The isomorphism signature is constructed entirely of printable characters, and has length proportional to `n log n`, where n is the number of top-dimenisonal simplices.

Isomorphism signatures are more general than dehydrations: they can be used with any triangulation (including closed, bounded and/or disconnected triangulations, as well as triangulations with large numbers of triangles).

The time required to construct the isomorphism signature of a triangulation is `O(n^2 log^2 n)`.

The routine fromIsoSig() can be used to recover a triangulation from an isomorphism signature. The triangulation recovered might not be identical to the original, but it will be combinatorially isomorphic.

If relabelling is non-null (i.e., it points to some Isomorphism pointer p), then it will be modified to point to a new isomorphism that describes the precise relationship between this triangulation and the reconstruction from fromIsoSig(). Specifically, the triangulation that is reconstructed from fromIsoSig() will be combinatorially identical to `relabelling.apply(this)`.

For a full and precise description of the isomorphism signature format for 3-manifold triangulations, see Simplification paths in the Pachner graphs of closed orientable 3-manifold triangulations, Burton, 2011, `arXiv:1110.6080`. The format for other dimensions is essentially the same, but with minor dimension-specific adjustments.

Python:
  The isomorphism argument is not present. Instead there are two routines: fromIsoSig(), which returns a string only, and fromIsoSigDetail(), which returns a pair (signature, relabelling).

Precondition
  If relabelling is non-null, then this triangulation must be non-empty and connected. The facility to return a relabelling for disconnected triangulations may be added to Regina in a later release.

Warning
  Do not mix isomorphism signatures between dimensions! It is possible that the same string could corresponding to both a p-dimensional triangulation and a q-dimensional triangulation for different p and q.

Parameters

  relabelling | if non-null, this will be modified to point to a new isomorphism describing the relationship between this triangulation and that reconstructed from fromIsoSig(), as described above.

Returns
  the isomorphism signature of this triangulation.

static size_t regina::NGenericTriangulation< dim >::isoSigComponentSize | ( | const std::string & | sig | ) |

static inherited

Deduces the number of top-dimensional simplices in a connected triangulation from its isomorphism signature.

See isoSig() for more information on isomorphism signatures. It will be assumed that the signature describes a triangulation of dimension dim.

If the signature describes a connected triangulation, this routine will simply return the size of that triangulation (e.g., the number of tetrahedra in the case dim = 3). You can also pass an isomorphism signature that describes a disconnected triangulation; however, this routine will only return the number of simplices in the first connected component. If you need the total number of simplices in a disconnected triangulation, you will need to reconstruct the full triangulation by calling fromIsoSig() instead.

This routine is very fast, since it only examines the first few characters of the isomorphism signature (in which the size of the first component is encoded). However, it is therefore possible to pass an invalid isomorphism signature and still receive a positive result. If you need to test whether a signature is valid or not, you must call fromIsoSig() instead, which will examine the entire signature in full.

Warning
  Do not mix isomorphism signatures between dimensions! It is possible that the same string could corresponding to both a p-dimensional triangulation and a q-dimensional triangulation for different p and q.

Parameters

  sig | an isomorphism signature of a dim-dimensional triangulation. Note that, unlike dehydration strings for 3-manifold triangulations, case is important for isomorphism signatures.

Returns
  the number of top-dimensional simplices in the first connected component, or 0 if this could not be determined because the given string was not a valid isomorphism signature.

bool regina::NPacket::isPacketEditable | ( |  | ) | const

inherited

Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children.

Descendants further down the packet tree are not (and should not need to be) considered.

Returns
  `true` if and only if this packet may be edited.

bool regina::NTriangulation::isSolidTorus | ( |  | ) | const

Determines whether this is a triangulation of the solid torus; that is, the unknot complement.

This routine can be used on a triangulation with real boundary triangles, or on an ideal triangulation (in which case all ideal vertices will be assumed to be truncated).

Warning
  The algorithms used in this routine rely on normal surface theory and so might be very slow for larger triangulations (although faster tests are used where possible). The routine knowsSolidTorus() can be called to see if this property is already known or if it happens to be very fast to calculate for this triangulation.

Returns
  `true` if and only if this is either a real (compact) or ideal (non-compact) triangulation of the solid torus.

bool regina::NTriangulation::isStandard | ( |  | ) | const

inline

Determines if this triangulation is standard.

This is the case if and only if every vertex is standard. See NVertex::isStandard() for further details.

Returns
  `true` if and only if this triangulation is standard.

bool regina::NTriangulation::isThreeSphere | ( |  | ) | const

Determines whether this is a triangulation of a 3-sphere.

This routine relies upon a combination of Rubinstein's 3-sphere recognition algorithm and Jaco and Rubinstein's 0-efficiency prime decomposition algorithm.

Warning
  The algorithms used in this routine rely on normal surface theory and so can be very slow for larger triangulations (although faster tests are used where possible). The routine knowsThreeSphere() can be called to see if this property is already known or if it happens to be very fast to calculate for this triangulation.

Returns
  `true` if and only if this is a 3-sphere triangulation.

bool regina::NTriangulation::isValid | ( |  | ) | const

inline

Determines if this triangulation is valid.

A triangulation is valid unless there is some vertex whose link has boundary but is not a disc (i.e., a vertex for which NVertex::getLink() returns NVertex::NON_STANDARD_BDRY), or unless there is some edge glued to itself in reverse (i.e., an edge for which NEdge::isValid() returns `false`).

Returns
  `true` if and only if this triangulation is valid.

bool regina::NTriangulation::isZeroEfficient | ( |  | ) |

Determines if this triangulation is 0-efficient.

A triangulation is 0-efficient if its only normal spheres and discs are vertex linking, and if it has no 2-sphere boundary components.

Returns
  `true` if and only if this triangulation is 0-efficient.

bool regina::NTriangulation::knowsBall | ( |  | ) | const

Is it already known (or trivial to determine) whether or not this is a triangulation of a 3-dimensional ball? See isBall() for further details.

If this property is indeed already known, future calls to isBall() will be very fast (simply returning the precalculated value).

If this property is not already known, this routine will nevertheless run some very fast preliminary tests to see if the answer is obviously no. If so, it will store `false` as the precalculated value for isBall() and this routine will return `true`.

Otherwise a call to isBall() may potentially require more significant work, and so this routine will return `false`.

Warning
  This routine does not actually tell you whether this triangulation forms a ball; it merely tells you whether the answer has already been computed (or is very easily computed).

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsCompressingDisc | ( |  | ) | const

Is it already known (or trivial to determine) whether or not the underlying 3-manifold contains a compressing disc? See hasCompressingDisc() for further details.

If this property is indeed already known, future calls to hasCompressingDisc() will be very fast (simply returning the precalculated value).

If this property is not already known, this routine will nevertheless run some very fast preliminary tests to see if the answer is obviously no. If so, it will store `false` as the precalculated value for hasCompressingDisc() and this routine will return `true`.

Otherwise a call to hasCompressingDisc() may potentially require more significant work, and so this routine will return `false`.

Warning
  This routine does not actually tell you whether the underlying 3-manifold has a compressing disc; it merely tells you whether the answer has already been computed (or is very easily computed).

Precondition
  This triangulation is valid and is not ideal.
  The underlying 3-manifold is irreducible.

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsHaken | ( |  | ) | const

Is it already known (or trivial to determine) whether or not the underlying 3-manifold is Haken? See isHaken() for further details.

If this property is indeed already known, future calls to isHaken() will be very fast (simply returning the precalculated value).

Warning
  This routine does not actually tell you whether the underlying 3-manifold is Haken; it merely tells you whether the answer has already been computed (or is very easily computed).

Precondition
  This triangulation is valid, closed, orientable and connected.

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsIrreducible | ( |  | ) | const

Is it already known (or trivial to determine) whether or not the underlying 3-manifold is irreducible? See isIrreducible() for further details.

If this property is indeed already known, future calls to isIrreducible() will be very fast (simply returning the precalculated value).

Warning
  This routine does not actually tell you whether the underlying 3-manifold is irreducible; it merely tells you whether the answer has already been computed (or is very easily computed).

Precondition
  This triangulation is valid, closed, orientable and connected.

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsSolidTorus | ( |  | ) | const

Is it already known (or trivial to determine) whether or not this is a triangulation of a solid torus (that is, the unknot complement)? See isSolidTorus() for further details.

If this property is indeed already known, future calls to isSolidTorus() will be very fast (simply returning the precalculated value).

If this property is not already known, this routine will nevertheless run some very fast preliminary tests to see if the answer is obviously no. If so, it will store `false` as the precalculated value for isSolidTorus() and this routine will return `true`.

Otherwise a call to isSolidTorus() may potentially require more significant work, and so this routine will return `false`.

Warning
  This routine does not actually tell you whether this triangulation forms a solid torus; it merely tells you whether the answer has already been computed (or is very easily computed).

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsSplittingSurface | ( |  | ) | const

inline

Is it already known whether or not this triangulation has a splitting surface? See hasSplittingSurface() for further details.

If this property is already known, future calls to hasSplittingSurface() will be very fast (simply returning the precalculated value).

Warning
  This routine does not actually tell you whether this triangulation has a splitting surface; it merely tells you whether the answer has already been computed.

Returns
  `true` if and only if this property is already known.

bool regina::NTriangulation::knowsStrictAngleStructure | ( |  | ) | const

Is it already known (or trivial to determine) whether or not this triangulation supports a strict angle structure? See hasStrictAngleStructure() for further details.

If this property is indeed already known, future calls to findStrictAngleStructure() and hasStrictAngleStructure() will be very fast (simply returning the precalculated solution).

Warning
  This routine does not actually tell you whether the triangulation supports a strict angle structure; it merely tells you whether the answer has already been computed (or is very easily computed).

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsThreeSphere | ( |  | ) | const

Is it already known (or trivial to determine) whether or not this is a triangulation of a 3-sphere? See isThreeSphere() for further details.

If this property is indeed already known, future calls to isThreeSphere() will be very fast (simply returning the precalculated value).

If this property is not already known, this routine will nevertheless run some very fast preliminary tests to see if the answer is obviously no. If so, it will store `false` as the precalculated value for isThreeSphere() and this routine will return `true`.

Otherwise a call to isThreeSphere() may potentially require more significant work, and so this routine will return `false`.

Warning
  This routine does not actually tell you whether this triangulation forms a 3-sphere; it merely tells you whether the answer has already been computed (or is very easily computed).

Returns
  `true` if and only if this property is already known or trivial to calculate.

bool regina::NTriangulation::knowsZeroEfficient | ( |  | ) | const

inline

Is it already known whether or not this triangulation is 0-efficient? See isZeroEfficient() for further details.

If this property is already known, future calls to isZeroEfficient() will be very fast (simply returning the precalculated value).

Warning
  This routine does not actually tell you whether this triangulation is 0-efficient; it merely tells you whether the answer has already been computed.

Returns
  `true` if and only if this property is already known.

NTetrahedron* regina::NTriangulation::layerOn | ( | NEdge * | edge | ) |

Performs a layering upon the given boundary edge of the triangulation.

See the NLayering class notes for further details on what a layering entails.

Precondition
  The given edge is a boundary edge of this triangulation, and the two boundary triangles on either side of it are distinct.

Parameters

  edge | the boundary edge upon which to layer.

Returns
  the new tetrahedron provided by the layering.

unsigned regina::NPacket::levelsDownTo | ( | const NPacket * | descendant | ) | const

inherited

Counts the number of levels between this packet and its given descendant in the tree structure.

If `descendant` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `descendant`, or can be obtained from `descendant` using only child-to-parent steps.

Parameters

  descendant | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

unsigned regina::NPacket::levelsUpTo | ( | const NPacket * | ancestor | ) | const

inline inherited

Counts the number of levels between this packet and its given ancestor in the tree structure.

If `ancestor` is this packet, the number of levels is zero.

Precondition
  This packet is equal to `ancestor`, or can be obtained from `ancestor` using only parent-to-child steps.

Parameters

  ancestor | the packet whose relationship with this packet we are examining.

Returns
  the number of levels difference.

bool regina::NPacket::listen | ( | NPacketListener * | listener | ) |

inherited

Registers the given packet listener to listen for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to register.

Returns
  `true` if the given listener was successfully registered, or `false` if the given listener was already registered beforehand.

bool regina::NGenericTriangulation< dim >::makeCanonical | ( |  | ) |

inherited

Relabel the top-dimensional simplices and their vertices so that this triangulation is in canonical form.

This is essentially the lexicographically smallest labelling when the facet gluings are written out in order.

Two triangulations are isomorphic if and only if their canonical forms are identical.

The lexicographic ordering assumes that the facet gluings are written in order of simplex index and then facet number. Each gluing is written as the destination simplex index followed by the gluing permutation (which in turn is written as the images of 0,1,...,dim in order).

Precondition
  This routine currently works only when the triangulation is connected. It may be extended to work with disconnected triangulations in later versions of Regina.

Returns
  `true` if the triangulation was changed, or `false` if the triangulation was in canonical form to begin with.

void regina::NTriangulation::makeDoubleCover | ( |  | ) |

Converts this triangulation into its double cover.

Each orientable component will be duplicated, and each non-orientable component will be converted into its orientable double cover.

void regina::NPacket::makeOrphan | ( |  | ) |

inherited

Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree.

The tree information for both this packet and its parent will be updated.

This routine takes small constant time.

Precondition
  This packet has a parent.
  This packet does not depend on its parent; see dependsOnParent() for details.

Python:
  As of Regina 4.6.1, this routine returns the packet itself, and the ownership of this packet becomes the responsibility of whoever takes this return value. In particular, if you call makeOrphan() and ignore the return value then the entire packet subtree is automatically destroyed. The reason for this behaviour is to avoid memory leaks where subtrees are orphaned and then silently forgotten.

std::string regina::NPacket::makeUniqueLabel | ( | const std::string & | base | ) | const

inherited

Returns a new label that cannot be found anywhere in the entire tree structure.

This packet need not be the tree matriarch; this routine will search the entire tree to which this packet belongs.

The new label will consist of the given base, possibly followed by a space and a number.

Deprecated:
  This routine is deprecated, since (as of Regina 4.95) packet labels in a data file are no longer required to be distinct.

Parameters

  base | a string upon which the new label will be based.

Returns
  a new unique label.

bool regina::NPacket::makeUniqueLabels | ( | NPacket * | reference | ) |

inherited

Ensures that all packet labels in both this and the given packet tree combined are distinct.

If two packets have the same label, one will be renamed by adding a space and a number.

Packets in the given packet tree will be given priority over the labels; that is, if a packet in this tree has the same label as a packet in the given tree, it will be the packet in this tree that is renamed.

The given packet tree may be `null`, in which case only this tree will be examined.

Deprecated:
  This routine is deprecated, since (as of Regina 4.95) packet labels in a data file are no longer required to be distinct.

Precondition
  This and the given packet belong to different packet trees, and are each matriarchs in their respective trees.

Parameters

  reference | the packet tree with which to compare this tree.

Returns
  `true` if and only if any of the packets were relabelled.

NPacket* regina::NTriangulation::makeZeroEfficient | ( |  | ) |

Converts this into a 0-efficient triangulation of the same underlying 3-manifold.

A triangulation is 0-efficient if its only normal spheres and discs are vertex linking, and if it has no 2-sphere boundary components.

Note that this routine is currently only available for closed orientable triangulations; see the list of preconditions for details. The 0-efficiency algorithm of Jaco and Rubinstein is used.

If the underlying 3-manifold is prime, it can always be made 0-efficient (with the exception of the special cases RP3 and S2xS1 as noted below). In this case the original triangulation will be modified directly and 0 will be returned.

If the underyling 3-manifold is RP3 or S2xS1, it cannot be made 0-efficient; in this case the original triangulation will be reduced to a two-tetrahedron minimal triangulation and 0 will again be returned.

If the underlying 3-manifold is not prime, it cannot be made 0-efficient. In this case the original triangulation will remain unchanged and a new connected sum decomposition will be returned. This will be presented as a newly allocated container packet with one child triangulation for each prime summand.

Warning
  The algorithms used in this routine rely on normal surface theory and so can be very slow for larger triangulations.

Precondition
  This triangulation is valid, closed, orientable and connected.

Returns
  0 if the underlying 3-manifold is prime (in which case the original triangulation was modified directly), or a newly allocated connected sum decomposition if the underlying 3-manifold is composite (in which case the original triangulation was not changed).

void regina::NTriangulation::maximalForestInBoundary | ( | std::set< NEdge * > & | edgeSet,
|  | std::set< NVertex * > & | vertexSet
| ) |  | const

Produces a maximal forest in the 1-skeleton of the triangulation boundary.

Both given sets will be emptied and the edges and vertices of the maximal forest will be placed into them. A vertex that forms its own boundary component (such as an ideal vertex) will still be placed in `vertexSet`.

Note that the edge and vertex pointers returned will become invalid once the triangulation has changed.

Python:
  Not present.

Parameters

  edgeSet | the set to be emptied and into which the edges of the maximal forest will be placed.
  vertexSet | the set to be emptied and into which the vertices of the maximal forest will be placed.

void regina::NTriangulation::maximalForestInDualSkeleton | ( | std::set< NTriangle * > & | triangleSet | ) | const

Produces a maximal forest in the triangulation's dual 1-skeleton.

The given set will be emptied and will have the triangles corresponding to the edges of the maximal forest in the dual 1-skeleton placed into it.

Note that the triangle pointers returned will become invalid once the triangulation has changed.

Python:
  This routine takes no arguments. Instead it returns the maximal forest as a Python list of NTriangle objects, sorted by triangle index.

Parameters

  triangleSet | the set to be emptied and into which the triangles representing the maximal forest will be placed.

void regina::NTriangulation::maximalForestInSkeleton | ( | std::set< NEdge * > & | edgeSet,
|  | bool | canJoinBoundaries = `true`
| ) |  | const

Produces a maximal forest in the triangulation's 1-skeleton.

The given set will be emptied and will have the edges of the maximal forest placed into it. It can be specified whether or not different boundary components may be joined by the maximal forest.

An edge leading to an ideal vertex is still a candidate for inclusion in the maximal forest. For the purposes of this algorithm, any ideal vertex will be treated as any other vertex (and will still be considered part of its own boundary component).

Note that the edge pointers returned will become invalid once the triangulation has changed.

Python:
  Not present.

Parameters

  edgeSet | the set to be emptied and into which the edges of the maximal forest will be placed.
  canJoinBoundaries | `true` if and only if different boundary components are allowed to be joined by the maximal forest.

void regina::NTriangulation::moveContentsTo | ( | NTriangulation & | dest | ) |

Moves the contents of this triangulation into the given destination triangulation, without destroying any pre-existing contents.

That is, all tetrahedra that currently belong to dest will remain there, and all tetrahedra that belong to this triangulation will be moved across as additional tetrahedra in dest.

All NTetrahedron pointers or references will remain valid. After this operation, this triangulation will be empty.

Parameters

  dest | the triangulation to which tetrahedra should be moved.

void regina::NPacket::moveDown | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the end of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very end of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

void regina::NPacket::moveToFirst | ( |  | ) |

inherited

Moves this packet to be the first in its sibling list.

This routine takes small constant time.

void regina::NPacket::moveToLast | ( |  | ) |

inherited

Moves this packet to be the last in its sibling list.

This routine takes small constant time.

void regina::NPacket::moveUp | ( | unsigned | steps = `1` | ) |

inherited

Moves this packet the given number of steps towards the beginning of its sibling list.

If the number of steps is larger than the greatest possible movement, the packet will be moved to the very beginning of its sibling list.

This routine takes time proportional to the number of steps.

Precondition
  The given number of steps is strictly positive.

NTetrahedron * regina::NTriangulation::newSimplex | ( |  | ) |

inline

A dimension-agnostic alias for newTetrahedron().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See newTetrahedron() for further information.

NTetrahedron * regina::NTriangulation::newSimplex | ( | const std::string & | desc | ) |

inline

A dimension-agnostic alias for newTetrahedron().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See newTetrahedron() for further information.

NTetrahedron * regina::NTriangulation::newTetrahedron | ( |  | ) |

inline

Creates a new tetrahedron and adds it to this triangulation.

The new tetrahedron will have an empty description. All four faces of the new tetrahedron will be boundary triangles.

The new tetrahedron will become the last tetrahedron in this triangulation.

Returns
  the new tetrahedron.

NTetrahedron * regina::NTriangulation::newTetrahedron | ( | const std::string & | desc | ) |

inline

Creates a new tetrahedron with the given description and adds it to this triangulation.

All four faces of the new tetrahedron will be boundary triangles.

Parameters

  desc | the description to assign to the new tetrahedron.

Returns
  the new tetrahedron.

NPacket* regina::NPacket::nextTreePacket | ( |  | ) |

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

const NPacket* regina::NPacket::nextTreePacket | ( |  | ) | const

inherited

Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs.

Note that this packet need not be the tree matriarch.

A parent packet is always reached before its children. The tree matriarch will be the first packet visited in a complete depth-first iteration.

Returns
  the next packet, or 0 if this is the last packet in such an iteration.

NPacket* regina::NPacket::nextTreePacket | ( | const std::string & | type | ) |

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

const NPacket* regina::NPacket::nextTreePacket | ( | const std::string & | type | ) | const

inherited

Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure.

Note that this packet need not be the tree matriarch. The order of tree searching is described in firstTreePacket().

Parameters

  type | the type of packet to search for, as returned by getPacketTypeName(). Note that string comparisons are case sensitive.

Returns
  the next such packet, or 0 if this is the last packet of the requested type in such an iteration.

bool regina::NTriangulation::oneFourMove | ( | NTetrahedron * | t,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 1-4 move upon the given tetrahedron.

This involves replacing one tetrahedron with four tetrahedra: each new tetrahedron runs from one face of the original tetrahedron to a new common internal degree four vertex.

This move can always be performed. The check argument is present (as for other moves), but is simply ignored (since the move is always legal). The perform argument is also present for consistency with other moves, but if it is set to `false` then this routine does nothing and returns no useful information.

Note that after performing this move, all skeletal objects (edges, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument t) can no longer be used.

Precondition
  The given tetrahedron is a tetrahedron of this triangulation.

Parameters

  t | the tetrahedron about which to perform the move.
  check | this argument is ignored, since this move is always legal (see the notes above).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  `true` always.

bool regina::NTriangulation::openBook | ( | NTriangle * | t,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a book opening move about the given triangle.

This involves taking a triangle meeting the boundary along two edges, and ungluing it to create two new boundary triangles (thus exposing the tetrahedra it initially joined). This move is the inverse of the closeBook() move, and is used to open the way for new shellBoundary() moves.

This move can be done if:

- the triangle meets the boundary in precisely two edges (and thus also joins two tetrahedra);
- the vertex between these two edges is a standard boundary vertex (its link is a disc);
- the remaining edge of the triangle (which is internal to the triangulation) is valid.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument f) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given triangle is a triangle of this triangulation.

Parameters

  t | the triangle about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NTriangulation::order | ( | bool | forceOriented = `false` | ) |

Relabels tetrahedron vertices in this triangulation to give an ordered triangulation, if possible.

To be an ordered triangulation, all face gluings (when restricted to the tetrahedron face) must be order preserving. In other words, it must be possible to orient all edges of the triangulation in such a fashion that they are consistent with the ordering of the vertices in each tetrahedron.

If it is possible to order this triangulation, the vertices of each tetrahedron will be relabelled accordingly and this routine will return `true`. Otherwise, this routine will return `false` and the triangulation will not be changed.

Warning
  This routine may be slow, since it backtracks through all possible edge orientations until a consistent one has been found.

Parameters

  forceOriented | `true` if the triangulation must be both ordered and oriented, in which case this routine will return `false` if the triangulation cannot be oriented and ordered at the same time. See orient() for further details.

Returns
  `true` if the triangulation has been successfully ordered as described above, or `false` if not.

Author
  Matthias Goerner

void regina::NTriangulation::orient | ( |  | ) |

Relabels tetrahedron vertices in this triangulation so that all tetrahedra are oriented consistently, if possible.

This routine works by flipping vertices 2 and 3 of each tetrahedron with negative orientation. The result will be a triangulation where the tetrahedron vertices are labelled in a way that preserves orientation across adjacent tetrahedron faces. In particular, every gluing permutation will have negative sign.

If this triangulation includes both orientable and non-orientable components, the orientable components will be oriented as described above and the non-orientable components will be left untouched.

Author
  Matthias Goerner

void regina::NTriangulation::puncture | ( | NTetrahedron * | tet = `0` | ) |

Punctures this manifold by removing a 3-ball from the interior of the given tetrahedron.

If no tetrahedron is specified (i.e., the tetrahedron pointer is `null`), then the puncture will be taken from the interior of tetrahedron 0.

The puncture will not meet the boundary of the tetrahedron, so nothing will go wrong if the tetrahedron has boundary facets and/or ideal vertices. A side-effect of this, however, is that the resulting triangulation will contain additional vertices, and will almost certainly be far from minimal. It is highly recommended that you run intelligentSimplify() if you do not need to preserve the combinatorial structure of the new triangulation.

The puncturing is done by subdividing the original tetrahedron. The new tetrahedra will have orientations consistent with the original tetrahedra, so if the triangulation was originally oriented then it will also be oriented after this routine has been called. See isOriented() for further details on oriented triangulations.

The new sphere boundary will be formed from two triangles; specifically, face 0 of the last and second-last tetrahedra of the triangulation. These two triangles will be joined so that vertex 1 of each tetrahedron coincides, and vertices 2,3 of one map to vertices 3,2 of the other.

Precondition
  This triangulation is non-empty, and if `tet` is non-null then it is in fact a tetrahedron of this triangulation.

Parameters

  tet | the tetrahedron inside which the puncture will be taken. This may be `null` (the default), in which case the first tetrahedron will be used.

std::string regina::NTriangulation::recogniser | ( |  | ) | const

Returns a string that expresses this triangulation in Matveev's 3-manifold recogniser format.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Returns
  a string containing the 3-manifold recogniser data.

void regina::NTriangulation::recogniser | ( | std::ostream & | out | ) | const

Writes a string expressing this triangulation in Matveev's 3-manifold recogniser format to the given output stream.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Python:
  Not present.

Parameters

  out | the output stream to which the recogniser data file will be written.

std::string regina::NTriangulation::recognizer | ( |  | ) | const

A synonym for recogniser().

This returns a string that expresses this triangulation in Matveev's 3-manifold recogniser format.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Returns
  a string containing the 3-manifold recogniser data.

void regina::NTriangulation::recognizer | ( | std::ostream & | out | ) | const

inline

A synonym for recognizer(std::ostream&).

This writes a string expressing this triangulation in Matveev's 3-manifold recogniser format to the given output stream.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Python:
  Not present.

Parameters

  out | the output stream to which the recogniser data file will be written.

static NTriangulation* regina::NTriangulation::rehydrate | ( | const std::string & | dehydration | ) |

static

Rehydrates the given alphabetical string into a new triangulation.

See dehydrate() for more information on dehydration strings.

This routine will rehydrate the given string into a new triangulation, and return this new triangulation.

The converse routine dehydrate() can be used to extract a dehydration string from an existing triangulation. Dehydration followed by rehydration might not produce a triangulation identical to the original, but it is guaranteed to produce an isomorphic copy. See dehydrate() for the reasons behind this.

For a full description of the dehydrated triangulation format, see A Census of Cusped Hyperbolic 3-Manifolds, Callahan, Hildebrand and Weeks, Mathematics of Computation 68/225, 1999.

Parameters

  dehydration | a dehydrated representation of the triangulation to construct. Case is irrelevant; all letters will be treated as if they were lower case.

Returns
  a newly allocated triangulation if the rehydration was successful, or null if the given string could not be rehydrated.

See also
  dehydrate
  insertRehydration

void regina::NTriangulation::removeAllSimplices | ( |  | ) |

inline

A dimension-agnostic alias for removeAllTetrahedra().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See removeAllTetrahedra() for further information.

void regina::NPacket::removeAllTags | ( |  | ) |

inherited

Removes all associated tags from this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

void regina::NTriangulation::removeAllTetrahedra | ( |  | ) |

inline

Removes all tetrahedra from the triangulation.

All tetrahedra will be deallocated.

void regina::NTriangulation::removeSimplex | ( | NTetrahedron * | tet | ) |

inline

A dimension-agnostic alias for removeTetrahedron().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See removeTetrahedron() for further information.

void regina::NTriangulation::removeSimplexAt | ( | unsigned long | index | ) |

inline

A dimension-agnostic alias for removeTetrahedronAt().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See removeTetrahedronAt() for further information.

bool regina::NPacket::removeTag | ( | const std::string & | tag | ) |

inherited

Removes the association of the given tag with this packet.

Each packet can have an arbitrary set of string tags associated with it. The tags are not used by this calculation engine; the feature is provided for whatever use a developer or user chooses to make of it.

Tags are case-sensitive. Tags associated with a single packet must be distinct, i.e., a particular tag cannot be associated more than once with the same packet.

Parameters

  tag | the tag to remove.

Returns
  `true` if the given tag was removed, or `false` if the given tag was not actually associated with this packet.

void regina::NTriangulation::removeTetrahedron | ( | NTetrahedron * | tet | ) |

inline

Removes the given tetrahedron from the triangulation.

All faces glued to this tetrahedron will be unglued. The tetrahedron will be deallocated.

Precondition
  The given tetrahedron exists in the triangulation.

Warning
  This routine has changed behaviour as of Regina 4.90. In older versions of Regina, the tetrahedron was returned to the user. As of Regina 4.90, the tetrahedron is now destroyed immediately.

Parameters

  tet | the tetrahedron to remove.

void regina::NTriangulation::removeTetrahedronAt | ( | unsigned long | index | ) |

inline

Removes the tetrahedron with the given index number from the triangulation.

Note that tetrahedron indexing may change when a tetrahedron is added or removed from the triangulation.

All faces glued to this tetrahedron will be unglued. The tetrahedron will be deallocated.

Warning
  This routine has changed behaviour as of Regina 4.90. In older versions of Regina, the tetrahedron was returned to the user. As of Regina 4.90, the tetrahedron is now destroyed immediately.

Parameters

  index | specifies which tetrahedron to remove; this should be between 0 and getNumberOfTetrahedra()-1 inclusive.

void regina::NTriangulation::reorderTetrahedraBFS | ( | bool | reverse = `false` | ) |

Reorders the tetrahedra of this triangulation using a breadth-first search, so that small-numbered tetrahedra are adjacent to other small-numbered tetrahedra.

Specifically, the reordering will operate as follows. Tetrahedron 0 will remain tetrahedron 0. Its immediate neighbours will be numbered 1, 2, 3 and 4 (though if these neighbours are not distinct then of course fewer labels will be required). Their immediate neighbours will in turn be numbered 5, 6, and so on, ultimately following a breadth-first search throughout the entire triangulation.

If the optional argument reverse is `true`, then tetrahedron numbers will be assigned in reverse order. That is, tetrahedron 0 will become tetrahedron n-1, its neighbours will become tetrahedra n-2 down to n-5, and so on.

Parameters

  reverse | `true` if the new tetrahedron numbers should be assigned in reverse order, as described above.

void regina::NPacket::reparent | ( | NPacket * | newParent,
|  | bool | first = `false`
| ) |  |

inherited

Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead.

This routine is essentially a combination of makeOrphan() followed by either insertChildFirst() or insertChildLast().

This routine takes small constant time. It is safe to use regardless of whether this packet has a parent or not.

Precondition
  This packet does not depend on its parent; see dependsOnParent() for details.
  The given parent is not a descendant of this packet.

Python:
  This routine is much simpler than combinations of makeOrphan() and insertChildFirst() / insertChildLast(), since there are no unpleasant ownership issues to deal with. However, if this packet currently has no parent then the ownership issues are unavoidable; in this case reparent() will do nothing, and one of the insertChild...() routines must be used instead.

Parameters

  newParent | the new parent of this packet, i.e., the packet beneath which this packet will be inserted.
  first | `true` if this packet should be inserted as the first child of the given parent, or `false` (the default) if it should be inserted as the last child.

bool regina::NPacket::save | ( | const char * | filename,
|  | bool | compressed = `true`
| ) |  | const

inherited

Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format.

The XML file may be optionally compressed (Regina can happily read both compressed and uncompressed XML).

This is the preferred way of saving a Regina data file. Typically this will be called from the root of the packet tree, which will save the entire packet tree to file.

Precondition
  The given packet does not depend on its parent.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written usign UTF-8.

Parameters

  filename | the pathname of the file to write to.
  compressed | `true` if the XML data should be compressed, or `false` if it should be written as plain text.

Returns
  `true` if and only if the file was successfully written.

bool regina::NTriangulation::saveRecogniser | ( | const char * | filename | ) | const

Writes this triangulation to the given file in Matveev's 3-manifold recogniser format.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written using UTF-8.

Parameters

  filename | the name of the Recogniser file to which to write.

Returns
  `true` if and only if the file was successfully written.

bool regina::NTriangulation::saveRecognizer | ( | const char * | filename | ) | const

inline

A synonym for saveRecogniser().

This writes this triangulation to the given file in Matveev's 3-manifold recogniser format.

Precondition
  This triangulation is not invalid, and does not contain any boundary triangles.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written using UTF-8.

Parameters

  filename | the name of the Recogniser file to which to write.

Returns
  `true` if and only if the file was successfully written.

virtual bool regina::NTriangulation::saveSnapPea | ( | const char * | filename | ) | const

virtual

Writes this triangulation to the given file using SnapPea's native file format.

Regarding what gets stored in the SnapPea data file:

- If you are calling this from one of Regina's own NTriangulation objects, then only the tetrahedron gluings and the manifold name will be stored (the name will be derived from the packet label). All other SnapPea-specific information (such as peripheral curves) will be marked as unknown (since Regina does not track such information itself), and of course other Regina-specific information (such as the Turaev-Viro invariants) will not be written to the SnapPea file at all.
- If you are calling this from the subclass NSnapPeaTriangulation, then all additional SnapPea-specific information will be written to the file (indeed, the SnapPea kernel itself will be used to produce the file contents).

If this triangulation is empty, invalid, or contains boundary triangles (which SnapPea cannot represent), then the file will not be written and this routine will return `false`.

Internationalisation:
  This routine makes no assumptions about the character encoding used in the given file name, and simply passes it through unchanged to low-level C/C++ file I/O routines. The contents of the file will be written using UTF-8.

Parameters

  filename | the name of the SnapPea file to which to write.

Returns
  `true` if and only if the file was successfully written.

Reimplemented in regina::NSnapPeaTriangulation.

void regina::NPacket::setPacketLabel | ( | const std::string & | newLabel | ) |

inherited

Sets the label associated with this individual packet.

Precondition
  No other packet in the overall tree structure has the same label.

Parameters

  newLabel | the new label to give this packet.

bool regina::NTriangulation::shellBoundary | ( | NTetrahedron * | t,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a boundary shelling move on the given tetrahedron.

This involves simply popping off a tetrahedron that touches the boundary. This can be done if:

- all edges of the tetrahedron are valid;
- precisely one, two or three faces of the tetrahedron lie in the boundary;
- if one face lies in the boundary, then the opposite vertex does not lie in the boundary, and no two of the remaining three edges are identified;
- if two faces lie in the boundary, then the remaining edge does not lie in the boundary, and the remaining two faces of the tetrahedron are not identified.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given tetrahedron is a tetrahedron of this triangulation.

Parameters

  t | the tetrahedron upon which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

long regina::NTriangulation::simplexIndex | ( | const NTetrahedron * | tet | ) | const

inline

A dimension-agnostic alias for tetrahedronIndex().

This is to assist with writing dimension-agnostic code that can be reused to work in different dimensions.

Here "simplex" refers to a top-dimensional simplex (which for 3-manifold triangulations means a tetrahedron).

See tetrahedronIndex() for further information.

void regina::NTriangulation::simplifiedFundamentalGroup | ( | NGroupPresentation * | newGroup | ) |

inline

Notifies the triangulation that you have simplified the presentation of its fundamental group.

The old group presentation will be destroyed, and this triangulation will take ownership of the new (hopefully simpler) group that is passed.

This routine is useful for situations in which some external body (such as GAP) has simplified the group presentation better than Regina can.

Regina does not verify that the new group presentation is equivalent to the old, since this is - well, hard.

If the fundamental group has not yet been calculated for this triangulation, this routine will nevertheless take ownership of the new group, under the assumption that you have worked out the group through some other clever means without ever having needed to call getFundamentalGroup() at all.

Note that this routine will not fire a packet change event.

Parameters

  newGroup | a new (and hopefully simpler) presentation of the fundamental group of this triangulation.

bool regina::NTriangulation::simplifyToLocalMinimum | ( | bool | perform = `true` | ) |

Uses all known simplification moves to reduce the triangulation monotonically to some local minimum number of tetrahedra.

Note that this will probably not give a globally minimal triangulation; see intelligentSimplify() for further assistance in achieving this goal.

The moves used include 3-2, 2-0 (edge and vertex), 2-1 and boundary shelling moves.

Note that moves that do not reduce the number of tetrahedra (such as 4-4 moves or book opening moves) are not used in this routine. Such moves do however feature in intelligentSimplify().

Warning
  The specific behaviour of this routine is very likely to change between releases.

Parameters

  perform | `true` if we are to perform the simplifications, or `false` if we are only to investigate whether simplifications are possible (defaults to `true`).

Returns
  if perform is `true`, this routine returns `true` if and only if the triangulation was changed to reduce the number of tetrahedra; if perform is `false`, this routine returns `true` if and only if it determines that it is capable of performing such a change.

virtual std::string regina::NTriangulation::snapPea | ( |  | ) | const

virtual

Returns a string containing the full contents of a SnapPea data file that describes this triangulation.

In particular, this string can be used in a Python session to pass the triangulation directly to SnapPy (without writing to the filesystem).

Regarding what gets stored in the SnapPea data file:

- If you are calling this from one of Regina's own NTriangulation objects, then only the tetrahedron gluings and the manifold name will be stored (the name will be derived from the packet label). All other SnapPea-specific information (such as peripheral curves) will be marked as unknown (since Regina does not track such information itself), and of course other Regina-specific information (such as the Turaev-Viro invariants) will not be written to the SnapPea file at all.
- If you are calling this from the subclass NSnapPeaTriangulation, then all additional SnapPea-specific information will be written to the file (indeed, the SnapPea kernel itself will be used to produce the file contents).

If you wish to export a triangulation to a SnapPea file, you should call saveSnapPea() instead (which has better performance, and does not require you to construct an enormous intermediate string).

If this triangulation is empty, invalid, or contains boundary triangles (which SnapPea cannot represent), then the resulting string will be empty.

Returns
  a string containing the contents of the corresponding SnapPea data file.

Reimplemented in regina::NSnapPeaTriangulation.

virtual void regina::NTriangulation::snapPea | ( | std::ostream & | out | ) | const

virtual

Writes the full contents of a SnapPea data file describing this triangulation to the given output stream.

Regarding what gets stored in the SnapPea data file:

- If you are calling this from one of Regina's own NTriangulation objects, then only the tetrahedron gluings and the manifold name will be stored (the name will be derived from the packet label). All other SnapPea-specific information (such as peripheral curves) will be marked as unknown (since Regina does not track such information itself), and of course other Regina-specific information (such as the Turaev-Viro invariants) will not be written to the SnapPea file at all.
- If you are calling this from the subclass NSnapPeaTriangulation, then all additional SnapPea-specific information will be written to the file (indeed, the SnapPea kernel itself will be used to produce the file contents).

If you wish to extract the SnapPea data file as a string, you should call the zero-argument routine snapPea() instead. If you wish to write to a real SnapPea data file on the filesystem, you should call saveSnapPea() (which is also available in Python).

If this triangulation is empty, invalid, or contains boundary triangles (which SnapPea cannot represent), then nothing will be written to the output stream.

Python:
  Not present.

Parameters

  out | the output stream to which the SnapPea data file will be written.

Reimplemented in regina::NSnapPeaTriangulation.

void regina::NPacket::sortChildren | ( |  | ) |

inherited

Sorts the immediate children of this packet according to their packet labels.

Note that this routine is not recursive (for instance, grandchildren will not be sorted within each child packet).

This routine takes quadratic time in the number of immediate children (and it's slow quadratic at that).

unsigned long regina::NTriangulation::splitIntoComponents | ( | NPacket * | componentParent = `0`,
|  | bool | setLabels = `true`
| ) |  |

Splits a disconnected triangulation into many smaller triangulations, one for each component.

The new component triangulations will be inserted as children of the given parent packet. The original triangulation will be left unchanged.

If the given parent packet is 0, the new component triangulations will be inserted as children of this triangulation.

This routine can optionally assign unique (and sensible) packet labels to each of the new component triangulations. Note however that uniqueness testing may be slow, so this assignment of labels should be disabled if the component triangulations are only temporary objects used as part of a larger routine.

Parameters

  componentParent | the packet beneath which the new component triangulations will be inserted, or 0 if they should be inserted directly beneath this triangulation.
  setLabels | `true` if the new component triangulations should be assigned unique packet labels, or `false` if they should be left without labels at all.

Returns
  the number of new component triangulations constructed.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

void regina::NTriangulation::swapContents | ( | NTriangulation & | other | ) |

Swaps the contents of this and the given triangulation.

That is, all tetrahedra that belong to this triangulation will be moved to other, and all tetrahedra that belong to other will be moved to this triangulation.

All NTetrahedron pointers or references will remain valid.

Parameters

  other | the triangulation whose contents should be swapped with this.

void regina::NPacket::swapWithNextSibling | ( |  | ) |

inherited

Swaps this packet with its next sibling in the sequence of children beneath their common parent packet.

Calling this routine is equivalent to calling moveDown().

This routine takes small constant time.

If this packet has no next sibling then this routine does nothing.

long regina::NTriangulation::tetrahedronIndex | ( | const NTetrahedron * | tet | ) | const

inline

Returns the index of the given tetrahedron in the triangulation.

Note that tetrahedron indexing may change when a tetrahedron is added or removed from the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getTetrahedronIndex(). The name has been changed because, unlike the old routine, it requires that the given tetrahedron belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given tetrahedron is contained in this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program. If you are passing the result of some other routine that might return null (such as NTetrahedron::adjacentTetrahedron), it might be worth explicitly testing for null beforehand.

Parameters

  tet | specifies which tetrahedron to find in the triangulation.

Returns
  the index of the specified tetrahedron, where 0 is the first tetrahedron, 1 is the second and so on.

bool regina::NTriangulation::threeTwoMove | ( | NEdge * | e,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 3-2 move about the given edge.

This involves replacing the three tetrahedra joined at that edge with two tetrahedra joined by a triangle. This can be done iff (i) the edge is valid and non-boundary, and (ii) the three tetrahedra are distinct.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument e) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

long regina::NTriangulation::triangleIndex | ( | const NTriangle * | triangle | ) | const

inline

Returns the index of the given triangle in the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getFaceIndex(). The name has been changed because, unlike the old routine, it requires that the given triangle belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given triangle belongs to this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program.

Parameters

  triangle | specifies which triangle to find in the triangulation.

Returns
  the index of the specified triangle, where 0 is the first triangle, 1 is the second and so on.

double regina::NTriangulation::turaevViro | ( | unsigned long | r,
|  | unsigned long | whichRoot
| ) |  | const

Computes the Turaev-Viro state sum invariant of this 3-manifold based upon the given initial data.

The initial data is as described in the paper of Turaev and Viro, "State sum invariants of 3-manifolds and quantum 6j-symbols", Topology, vol. 31, no. 4, 1992, pp 865-902.

In particular, Section 7 describes the initial data as determined by an integer r >=3 and a root of unity q0 of degree 2r for which q0^2 is a primitive root of unity of degree r.

These invariants, although computed in the complex field, should all be reals. Thus the return type is an ordinary double.

Precondition
  This triangulation is valid, closed and non-empty.

Parameters

  r | the integer r as described above; this must be at least 3.
  whichRoot | determines q0 to be the root of unity e^(2i * Pi * whichRoot / 2r); this argument must be strictly between 0 and 2r and must have no common factors with r.

Returns
  the requested Turaev-Viro invariant.

See also
  allCalculatedTuraevViro

bool regina::NTriangulation::twoOneMove | ( | NEdge * | e,
|  | int | edgeEnd,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 2-1 move about the given edge.

This involves taking an edge meeting only one tetrahedron just once and merging that tetrahedron with one of the tetrahedra joining it.

This can be done assuming the following conditions:

- The edge must be valid and non-boundary.
- The two remaining faces of the tetrahedron are not joined, and the tetrahedron face opposite the given endpoint of the edge is not boundary.
- Consider the second tetrahedron to be merged (the one joined along the face opposite the given endpoint of the edge). Moreover, consider the two edges of this second tetrahedron that run from the (identical) vertices of the original tetrahedron not touching `e` to the vertex of the second tetrahedron not touching the original tetrahedron. These edges must be distinct and may not both be in the boundary.

There are additional "distinct and not both boundary" conditions on faces of the second tetrahedron, but those follow automatically from the final condition above.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument e) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge about which to perform the move.
  edgeEnd | the end of the edge opposite that at which the second tetrahedron (to be merged) is joined. The end is 0 or 1, corresponding to the labelling (0,1) of the vertices of the edge as described in NEdgeEmbedding::getVertices().
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NTriangulation::twoThreeMove | ( | NTriangle * | t,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 2-3 move about the given triangle.

This involves replacing the two tetrahedra joined at that triangle with three tetrahedra joined by an edge. This can be done iff the two tetrahedra are distinct.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument f) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given triangle is a triangle of this triangulation.

Parameters

  t | the triangle about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NTriangulation::twoZeroMove | ( | NEdge * | e,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 2-0 move about the given edge of degree 2.

This involves taking the two tetrahedra joined at that edge and squashing them flat. This can be done if:

- the edge is valid and non-boundary;
- the two tetrahedra are distinct;
- the edges opposite `e` in each tetrahedron are distinct and not both boundary;
- if triangles f1 and f2 from one tetrahedron are to be flattened onto triangles g1 and g2 of the other respectively, then (a) f1 and g1 are distinct, (b) f2 and g2 are distinct, (c) we do not have both f1 = g2 and g1 = f2, (d) we do not have both f1 = f2 and g1 = g2, and (e) we do not have two of the triangles boundary and the other two identified.

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument e) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given edge is an edge of this triangulation.

Parameters

  e | the edge about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NTriangulation::twoZeroMove | ( | NVertex * | v,
|  | bool | check = `true`,
|  | bool | perform = `true`
| ) |  |

Checks the eligibility of and/or performs a 2-0 move about the given vertex of degree 2.

This involves taking the two tetrahedra joined at that vertex and squashing them flat. This can be done if:

- the vertex is non-boundary and has a 2-sphere vertex link;
- the two tetrahedra are distinct;
- the triangles opposite `v` in each tetrahedron are distinct and not both boundary;
- the two tetrahedra meet each other on all three faces touching the vertex (as opposed to meeting each other on one face and being glued to themselves along the other two).

If the routine is asked to both check and perform, the move will only be performed if the check shows it is legal.

Note that after performing this move, all skeletal objects (triangles, components, etc.) will be reconstructed, which means any pointers to old skeletal objects (such as the argument v) can no longer be used.

Precondition
  If the move is being performed and no check is being run, it must be known in advance that the move is legal.
  The given vertex is a vertex of this triangulation.

Parameters

  v | the vertex about which to perform the move.
  check | `true` if we are to check whether the move is allowed (defaults to `true`).
  perform | `true` if we are to perform the move (defaults to `true`).

Returns
  If check is `true`, the function returns `true` if and only if the requested move may be performed without changing the topology of the manifold. If check is `false`, the function simply returns `true`.

bool regina::NPacket::unlisten | ( | NPacketListener * | listener | ) |

inherited

Unregisters the given packet listener so that it no longer listens for events on this packet.

See the NPacketListener class notes for details.

Python:
  Not present.

Parameters

  listener | the listener to unregister.

Returns
  `true` if the given listener was successfully unregistered, or `false` if the given listener was not registered in the first place.

long regina::NTriangulation::vertexIndex | ( | const NVertex * | vertex | ) | const

inline

Returns the index of the given vertex in the triangulation.

This routine was introduced in Regina 4.5, and replaces the old getVertexIndex(). The name has been changed because, unlike the old routine, it requires that the given vertex belongs to the triangulation (a consequence of some significant memory optimisations).

Precondition
  The given vertex belongs to this triangulation.

Warning
  Passing a null pointer to this routine will probably crash your program.

Parameters

  vertex | specifies which vertex to find in the triangulation.

Returns
  the index of the specified vertex, where 0 is the first vertex, 1 is the second and so on.

virtual void regina::NTriangulation::writeTextLong | ( | std::ostream & | out | ) | const

virtual

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented from regina::ShareableObject.

Reimplemented in regina::NSnapPeaTriangulation.

void regina::NTriangulation::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

Reimplemented in regina::NSnapPeaTriangulation.

void regina::NPacket::writeXMLFile | ( | std::ostream & | out | ) | const

inherited

Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format.

Ths is similar to calling save(), except that (i) the user has a more flexible choice of output stream, and (ii) the XML will always be written in plain text (i.e., it will not be compressed).

If you simply wish to save your data to a file on the filesystem, you should call save() instead.

Typically this will be called from the root of the packet tree, which will write the entire packet tree to the output stream.

The output from this routine cannot be used as a piece of an XML file; it must be the entire XML file. For a piece of an XML file, see routine writeXMLPacketTree() instead.

Precondition
  This packet does not depend upon its parent.

Python:
  Not present.

Parameters

  out | the output stream to which the XML data file should be written.

virtual void regina::NTriangulation::writeXMLPacketData | ( | std::ostream & | out | ) | const

protected virtual

Writes a chunk of XML containing the data for this packet only.

You may assume that the packet opening tag (including the packet type and label) has already been written, and that all child packets followed by the corresponding packet closing tag will be written immediately after this routine is called. This routine need only write the internal data stored in this specific packet.

Parameters

  out | the output stream to which the XML should be written.

Implements regina::NPacket.

Reimplemented in regina::NSnapPeaTriangulation.

void regina::NPacket::writeXMLPacketTree | ( | std::ostream & | out | ) | const

protected inherited

Writes a chunk of XML containing the subtree with this packet as matriarch.

This is the preferred way of writing a packet tree to file.

The output from this routine is only a piece of XML; it should not be used as a complete XML file. For a complete XML file, see routine writeXMLFile() instead.

Parameters

  out | the output stream to which the XML should be written.

The documentation for this class was generated from the following file:

- triangulation/ntriangulation.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).